<?php
require_once '../../data/constant.php';
$err_msg = "";
$conn = "";
$data_object = null;
if (NO_SINGLE_SIGNON == 0) {
	require('../../../../mainfile.php');
	require_once '../../data/xdb_access.php';
} else if (NO_SINGLE_SIGNON == 1) {
	require_once '../../data/db_access.php';
	ini_set("session.save_handler","files");
	session_start();
	$data_object = new CDbAccess();
	if ($data_object->openDB() == false) {
		$err_msg .= $data_object->err_msg;
	} else {
		$conn = $data_object->conn;
	}
}
require_once '../../util/post_util.php';
require_once '../../util/make_item.php';
require_once '../../util/validate.php';
require_once '../../data/table_access.php';

//ini_set("session.save_handler","files");
//session_start();
if (!isset($_SESSION[SESSION_ADMIN])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."teacher/login.php");
	exit;
} else {
	$ses_arr = $_SESSION[SESSION_ADMIN];
	$admin_status =$ses_arr['status'];
	$admin_id=$ses_arr['teacher_id'];
	$material_title = "";
	$action_file = "confirm_mat.php";
	$material_url = "";
	$url_visible = "inline";
	$list_visible = "none";
	$comment="";
	$for_del= "";
	$for_up = "";
	$department_sel = "";
	$material_id = "";
	$action_type = "insert";
	$department_id = "";

	$file_list2="";
	$current_ufold= MAT_PATH."user".$admin_id."/";
	$current_url= MAT_URL."user".$admin_id."/";
	$ufolder_checked = "";
	$list_visible2 ="none";
	$is_pub_checked = "";
	$is_pub="";
	$disable_pub = "";
	$is_ulist = "";

	//롼׽°λ
	$groupid = "";
	$current_gfold= "";
	$current_gurl= "";
	$gfolder_checked = "";
	$group_visible ="none";
	$list_visible3 = "none";
	$is_glist = "";

	//зѤΥΡȥ
	$note_key_visible = "hidden";
	$note_key_cnt = 0;

	if (isset($_GET["material_id"]) && is_numeric($_GET["material_id"])) {
		$material_id = $_GET["material_id"];
		$action_type = "update";
		$material_object = new CMaterialTableAccess();
		$material_data = $material_object->getDetailMat($conn,$material_id);
		if ($material_data <> false) {
			$material_title=htmlspecialchars($material_data["material_title"],ENT_QUOTES);
			$material_url=htmlspecialchars($material_data["material_url"],ENT_QUOTES);
			$comment=htmlspecialchars($material_data["material_comment"],ENT_QUOTES);
			$department_id = $material_data["department_id"];
			$note_key_visible = "visible";
			if ($material_data["is_pub"] == 1) {
				$is_pub_checked = "CHECKED";
				$is_pub = 1;
			}
			if ($admin_status <> 1 && $admin_id <> $material_data["create_user"]) {
				$disable_pub = "DISABLED";
			}
			$note_key_object = new CNoteKeywordTableAccess();
			$note_key_cnt =
				$note_key_object->getNoteKeysPerEventCnt($conn,$material_id,1);

		} else {
			$err_msg .= "NO DATA";
		}
	}

	if (isset($_GET["is_ulist"]) && $_GET["is_ulist"] == 1) {
	if (isset($_REQUEST["current_ufold"]) && $_REQUEST["current_ufold"] <> "") {
		//桼˲̤Υեꤷ
		$tmp_uflod = chPostToNormal($_REQUEST["current_ufold"]);
		if (substr($tmp_uflod,0,strlen($current_ufold)) == $current_ufold) {
			$current_ufold = $tmp_uflod;
			$current_url = str_replace(MAT_PATH, MAT_URL, $current_ufold);
			$url_visible = "none";
			$list_visible2 = "inline";
		}
	}
	//if (isset($_GET["is_ulist"]) && $_GET["is_ulist"] == 1) {
		$ufolder_checked = "CHECKED";
		$is_ulist=1;
	}
	if (isset($_GET["is_pub"]) && $_GET["is_pub"] == 1) {
		$is_pub = 1;
		$is_pub_checked = "CHECKED";
	}

	if (isset($_GET["groupid"]) && $_GET["groupid"] <> "" && is_numeric($_GET["groupid"])) {
		$groupid = $_GET["groupid"];
		$group_visible = "inline";
		$current_gfold= MAT_PATH."group".$groupid."/";
		$current_gurl= MAT_URL."group".$groupid."/";

		if (!is_dir($current_gfold)) {
			mkdir($current_gfold);
		}

		if (isset($_GET["is_glist"]) && $_GET["is_glist"] == 1) {
		if (isset($_REQUEST["current_gfold"]) && $_REQUEST["current_gfold"] <> "") {
			//桼˲̤Υ롼ץեꤷ
			$tmp_gflod = chPostToNormal($_REQUEST["current_gfold"]);
			if (substr($tmp_gflod,0,strlen($current_gfold)) == $current_gfold) {
				$current_gfold = $tmp_gflod;
				$current_gurl = str_replace(MAT_PATH, MAT_URL, $current_gfold);
				$url_visible = "none";
				$list_visible3 = "inline";
			}
		}
//		if (isset($_GET["is_glist"]) && $_GET["is_glist"] == 1) {
			$gfolder_checked = "CHECKED";
			$is_glist = 1;
		}
	}

	//ե󥸤бư
	if (isset($_GET["material_title"])) {
	$material_title=htmlspecialchars($_GET["material_title"],ENT_QUOTES);
	}
	if (isset($_GET["material_comment"])) {
	$comment=htmlspecialchars($_GET["material_comment"],ENT_QUOTES);
	}
	if (isset($_GET["department_id"])) {
	$department_id = $_GET["department_id"];
	}

	$dep_object = new CCreateDepSelect($conn);
	$dep_object->setDataForInput();
	$department_sel = $dep_object->getPullDown("department_id", $department_id);

	$file_list = "";
	$res_dir = opendir(MAT_PATH);
	while ($file_name = readdir($res_dir)) {
		if ($file_name != "." && $file_name != ".." && is_file(MAT_PATH.$file_name)) {
			$file_list .= "<input type='radio' name='urlselect' value='";
			$file_list .= htmlspecialchars($file_name,2)."'>";
			$file_list .= "<a href='#' onclick=\"javascript:window.open('".MAT_URL.htmlspecialchars($file_name,2)."','material', 'width=400, height=300, menubar=no, toolbar=no, scrollbars=yes');\">";

			if (mb_eregi("\.ppt|\.pptx|\.odp|\.pdf|\.doc|\.docx|\.odt|\.xsl|\.xls|\.xlsx|\.ppsx|\.sldx$",$file_name)) {
			$file_list .= "<iframe src='http://docs.google.com/gview?url=".MAT_URL.htmlspecialchars($file_name,2)."&embedded=true' STYLE='zoom:50%' Scrolling='no'></iframe>";
			} else {
			$file_list .= "<iframe src='".MAT_URL.htmlspecialchars($file_name,2)."' STYLE='zoom:50%' Scrolling='no'></iframe>";
			}
			$file_list .= htmlspecialchars($file_name,2)."</a>";
			$file_list .= "<br/>";
		}
	}

	if (is_dir($current_ufold)) {
		$res_dir = opendir($current_ufold);
		while ($file_name = readdir($res_dir)) {
			if ($file_name != "." && $file_name != "..") {
			if (is_file($current_ufold.$file_name)) {
				$file_list2 .= "<input type='radio' name='urlselect' value='";
				$file_list2 .= htmlspecialchars($current_url.$file_name,2)."'>";
				$file_list2 .= "<a href='#' onclick=\"javascript:window.open('".$current_url.htmlspecialchars($file_name,2)."','material', 'width=400, height=300, menubar=no, toolbar=no, scrollbars=yes');\">";

				if (mb_eregi("\.ppt|\.pptx|\.odp|\.pdf|\.doc|\.docx|\.odt|\.xsl|\.xls|\.xlsx|\.ppsx|\.sldx$",$file_name)) {
				$file_list2 .= "<iframe src='http://docs.google.com/gview?url=".$current_url.htmlspecialchars($file_name,2)."&embedded=true' STYLE='zoom:50%' Scrolling='no'></iframe>";
				} else {
				$file_list2 .= "<iframe src='".$current_url.htmlspecialchars($file_name,2)."' STYLE='zoom:50%' Scrolling='no'></iframe>";
				}
				$file_list2 .= htmlspecialchars($file_name,2)."</a>";
				$file_list2 .= "<br/>";
			} else if (is_dir($current_ufold.$file_name)) {
//				$file_list2 .= "<a href='insert_mat.php?groupid=".$groupid."&current_gfold=".urlencode($current_gfold)."&material_id=".$material_id."&current_ufold=".urlencode($current_ufold.$file_name."/")."&is_ulist=1&is_glist=".$is_glist."&is_pub=".$is_pub."'><img src='../../images/folder.png' width=20 height=15 border=0/>";
				$file_list2 .= "<a href='#' onClick='onFolderChange(\"".htmlspecialchars($current_ufold.$file_name."/",ENT_QUOTES)."\",\"".htmlspecialchars($current_gfold,ENT_QUOTES)."\")'><img src='../../images/folder.png' width=20 height=15 border=0/>";

				$file_list2 .= htmlspecialchars($file_name,ENT_QUOTES)."</a><br/>";
			}
			}
		}
		if ($current_ufold <> MAT_PATH."user".$admin_id."/") {
			//$file_list2 .= "<a href='insert_mat.php?groupid=".$groupid."&current_gfold=".urlencode($current_gfold)."&material_id=".$material_id."&current_ufold=".urlencode(dirname($current_ufold)."/")."&is_ulist=1&is_glist=".$is_glist."&is_pub=".$is_pub."'><img src='../../images/folder.png' width=20 height=15 border=0/>..</a>";
			$file_list2 .= "<a href='#' onClick='onFolderChange(\"".htmlspecialchars(dirname($current_ufold)."/",ENT_QUOTES)."\",\"".htmlspecialchars($current_gfold,ENT_QUOTES)."\")'><img src='../../images/folder.png' width=20 height=15 border=0/>..</a>";

		}
	}

	if ($groupid <> "" && is_numeric($groupid)) {
		$res_dir = opendir($current_gfold);
		while ($file_name = readdir($res_dir)) {
			if ($file_name != "." && $file_name != "..") {
				if (is_file($current_gfold.$file_name)) {
				$file_list3 .= "<input type='radio' name='urlselect' value='";
				$file_list3 .= htmlspecialchars($current_gurl.$file_name,2)."'>";
				$file_list3 .= "<a href='#' onclick=\"javascript:window.open('".$current_gurl.htmlspecialchars($file_name,2)."','material', 'width=400, height=300, menubar=no, toolbar=no, scrollbars=yes');\">";

				if (mb_eregi("\.ppt|\.pptx|\.odp|\.pdf|\.doc|\.docx|\.odt|\.xsl|\.xls|\.xlsx|\.ppsx|\.sldx$",$file_name)) {
				$file_list3 .= "<iframe src='http://docs.google.com/gview?url=".$current_gurl.htmlspecialchars($file_name,2)."&embedded=true' STYLE='zoom:50%' Scrolling='no'></iframe>";
				} else {
				$file_list3 .= "<iframe src='".$current_gurl.htmlspecialchars($file_name,2)."' STYLE='zoom:50%' Scrolling='no'></iframe>";
				}
				$file_list3 .= htmlspecialchars($file_name,2)."</a>";
				$file_list3 .= "<br/>";
				} else if (is_dir($current_gfold.$file_name)) {
				//$file_list3 .= "<a href='insert_mat.php?groupid=".$groupid."&current_gfold=".urlencode($current_gfold.$file_name."/")."&material_id=".$material_id."&current_ufold=".urlencode($current_ufold)."&is_ulist=".$is_ulist."&is_glist=1&is_pub=".$is_pub."'><img src='../../images/folder.png' width=20 height=15 border=0/>";
				$file_list3 .= "<a href='#' onClick='onFolderChange(\"".htmlspecialchars($current_ufold,ENT_QUOTES)."\",\"".htmlspecialchars($current_gfold.$file_name."/",ENT_QUOTES)."\")'><img src='../../images/folder.png' width=20 height=15 border=0/>";
				$file_list3 .= htmlspecialchars($file_name,ENT_QUOTES)."</a><br/>";
				}
			}
		}
		if ($current_gfold <> MAT_PATH."group".$groupid."/") {
			//$file_list3 .= "<a href='insert_mat.php?groupid=".$groupid."&current_gfold=".urlencode(dirname($current_gfold)."/")."&material_id=".$material_id."&current_ufold=".urlencode($current_ufold)."&is_ulist=".$is_ulist."&is_glist=1&is_pub=".$is_pub."'><img src='../../images/folder.png' width=20 height=15 border=0/>..</a>";
			$file_list3 .= "<a href='#' onClick='onFolderChange(\"".htmlspecialchars($current_ufold,ENT_QUOTES)."\",\"".htmlspecialchars(dirname($current_gfold)."/",ENT_QUOTES)."\")'><img src='../../images/folder.png' width=20 height=15 border=0/>..</a>";
		}
	}

	if ($conn <> "" && is_object($data_object)) $data_object->closeDB();
	$show_data = file_get_contents(TEMPLATE_DIR.'ad_material_reg/material_form.tpl');
	$show_data = str_replace(':FILE_LIST_REP:',$file_list,$show_data);
	$show_data = str_replace(':FILE_NAME:',$action_file,$show_data);

	$show_data = str_replace(':MAT_TITLE_REP:',$material_title,$show_data);
	$show_data = str_replace(':MAT_URL_REP:',$material_url,$show_data);
	$show_data = str_replace(':MAT_URL_TEXT_DISPLAY_REP:',$url_visible,$show_data);
	$show_data = str_replace(':MAT_PAGE_LIST_DISPLAY_REP:',$list_visible,$show_data);
	$show_data = str_replace(':COMMENT_REP:',$comment,$show_data);

	$show_data = str_replace(':ACT_TYPE_REP:',$action_type,$show_data);
	$show_data = str_replace(':UP_ID_REP:',$material_id,$show_data);
	$show_data = str_replace(':DEPARTMENT_SEL_REP:',$department_sel,$show_data);

	$show_data = str_replace(':ERR_MSG:',$err_msg,$show_data);
	$show_data = str_replace(':FOR_DEL:',$for_del,$show_data);
	$show_data = str_replace(':FOR_UP:',$for_up,$show_data);

	$show_data = str_replace(':MAT_PAGE_ULIST_DISPLAY_REP:',$list_visible2,$show_data);
	$show_data = str_replace(':FILE_LIST_REP2:',$file_list2,$show_data);
	$show_data = str_replace(':IS_UFOLDER_CHECHED:',$ufolder_checked,$show_data);
	$show_data = str_replace(':IS_PUB_REP:',$is_pub_checked,$show_data);
	$show_data = str_replace(':IS_PUB_DIA_REP:',$disable_pub,$show_data);

	$show_data = str_replace(':GID_REP:',$groupid,$show_data);
	$show_data = str_replace(':GLIST_VISIBLE_REP:',$group_visible,$show_data);
	$show_data = str_replace(':IS_GFOLDER_CHECHED:',$gfolder_checked,$show_data);
	$show_data = str_replace(':MAT_PAGE_GLIST_DISPLAY_REP:',$list_visible3,$show_data);
	$show_data = str_replace(':FILE_LIST_REP3:',$file_list3,$show_data);

	$show_data = str_replace(':NOTE_KEY_SHOW_REP:',$note_key_visible,$show_data);
	$show_data = str_replace(':KEY_CNT_REP:',$note_key_cnt,$show_data);

	echo $show_data;
}
?>