<?php
require_once '../../data/constant.php';
$err_msg = "";
$conn = "";
$data_object = null;
if (NO_SINGLE_SIGNON == 0) {
	require('../../../../mainfile.php');
	require_once '../../data/xdb_access.php';
} else if (NO_SINGLE_SIGNON == 1) {
	require_once '../../data/db_access.php';
	ini_set("session.save_handler","files");
	session_start();
	$data_object = new CDbAccess();
	if ($data_object->openDB() == false) {
		$err_msg .= $data_object->err_msg;
	} else {
		$conn = $data_object->conn;
	}
}
require_once '../../util/post_util.php';
require_once '../../data/table_access.php';
require_once '../../data/data_for_lec.php';

if (!isset($_SESSION[SESSION_ADMIN])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."teacher/login.php");
	exit;
}
$event_id = "";
$event_type = "";
$event_view_cond = "";
$js_note_key_arr = "";
$total_score=0;
$is_editable="DISABLED";
$key_words_table = "";
$key_cnt=0;

if (isset($_GET["event_id"])) $event_id = $_GET["event_id"];
if (isset($_GET["event_type"])) $event_type = $_GET["event_type"];
if ($event_type == 1) {
	$event_view_cond = "material_id=".intval($event_id);
} elseif ($event_type == 2) {
	$event_view_cond = "practice_id=".intval($event_id);
} elseif ($event_type == 3) {
	$event_view_cond = "vote_id=".intval($event_id);
} elseif ($event_type == 4) {
	$event_view_cond = "quiz_id=".intval($event_id);
}

//Ρȥɤθ
$key_words_object = new CKeywordsForEventData();
if ($key_words_object->setKeywordsList($conn, $event_id,$event_type)) {
	$pre_key_id = "";
	while ($res = $key_words_object->dbFetchArr()){
		$is_editable = "";
		$total_cand_num = 0;
		if ($res["note_keyword_id"] <> $pre_key_id) {
			if ($pre_key_id <> "") {
				$key_words_table .= "</td><td valign='top'>".$last_score;
				$key_words_table .="</td><td valign='top'>";

				$key_words_table .="<input type='text' id=";
				$key_words_table .="'new_key_cand_".$pre_key_id;
				$key_words_table .="' name='new_key_cand_".$pre_key_id;

				$key_words_table .="' size=20 maxlength=50/>";
				$key_words_table .=_NORM_TEA_LEC_NOTE_CAND_ADD."<input type=";
				$key_words_table .="'button' value='"._COMMON_ADD_TXT."' onClick='addKeyCand(".$pre_key_id.")'/></td></tr>";
			}
			$key_words_table .= "<tr";
			if ($key_cnt%2 == 0) $key_words_table .= " bgcolor='lightgreen'";
			$key_words_table .= "><td valign='top'><input type='checkbox' name='del_".$key_cnt."'";
			$key_words_table .= "value=".$res["note_keyword_id"]." />Key Word".($key_cnt+1)."</td>";
			$key_words_table .= "<td valign='top'>";
			$key_words_table .= "<input type='hidden' name='note_key_id_".$key_cnt."'";
			$key_words_table .= " value='".intval($res["note_keyword_id"])."'/>";
			$i=0;
		}
		if ($i>0) $key_words_table .= _NORM_COMMON_KEY_CANDIDATE."<br/>";
		$key_words_table .= "<input type='text' name='key_cand_".intval($res["note_keyword_id"])."_".$i."'";
		$key_words_table .= "value='".htmlspecialchars($res["key_word_text"],ENT_QUOTES);
		$key_words_table .= "' id ='cand_no_".$total_cand_num."'";
		$key_words_table .= " size=20 maxlength=50/>";
		$js_note_key_arr .= ",'".htmlspecialchars($res["key_word_text"],ENT_QUOTES)."'";
		$total_cand_num++;
		$i++;
		if ($res["note_keyword_id"] <> $pre_key_id) {
		$total_score += intval($res["score"]);
		$key_cnt++;
		}
		$last_score = $res["score"];
		$pre_key_id = $res["note_keyword_id"];

	}
	if ($key_words_table <> "") {
		$key_words_table .= "</td><td valign='top'>".$last_score;
		$key_words_table .="</td><td valign='top'><input type='text' id=";
		$key_words_table .="'new_key_cand_".$pre_key_id;
		$key_words_table .="' name = 'new_key_cand_".$pre_key_id."' size=20 maxlength=50/>";
		$key_words_table .=_NORM_TEA_LEC_NOTE_CAND_ADD."<input type=";
		$key_words_table .="'button' value='"._COMMON_ADD_TXT."' onClick='addKeyCand(".$pre_key_id.")'/></td></tr>";
	}

	$key_words_object->dbFreeResult();
}



if ($conn <> "" && is_object($data_object)) $data_object->closeDB();
$show_data = file_get_contents(TEMPLATE_DIR.'ad_material_reg/set_note_key_form.tpl');

$show_data = str_replace(':EVENT_VIEW_COND_REP:', $event_view_cond, $show_data);
$show_data = str_replace(':JS_NOTE_KEY_ARR_REP:', $js_note_key_arr, $show_data);
$show_data = str_replace(':EVENT_ID_REP:', $event_id, $show_data);
$show_data = str_replace(':EVENT_TYPE_REP:', $event_type, $show_data);
$show_data = str_replace(':TOTAL_SCORE_REP:', $total_score, $show_data);
$show_data = str_replace(':IS_EDITABLE_REP:', $is_editable, $show_data);
$show_data = str_replace(':KEY_CNT_REP:', $key_cnt, $show_data);
$show_data = str_replace(':KEY_WORDS_TABLE_REP:', $key_words_table, $show_data);
$show_data = str_replace(':TOTAL_CAND_REP:', $total_cand_num, $show_data);

echo $show_data;
?>