<?php
class CMakeLectureFrame {
	//ѤΥڡ

	var $main_frame="";
	var $lecture_nam = "";
	var $sub_frame = array();
	var $current_event = "";
	var $lecture_object;
	var $conn=null;
	var $lecture_id=0;
	var $err_msg = "";
	var $invite_key=0;
	var $event_link_object;
	var $lec_status;
	var $pres_key;
	var $pres_type;

	var $event_link_csv = "";

	function CMakeLectureFrame () {
		$this->lecture_object = new CLectureTableAccess();
		$this->event_link_object = new CEventLinkTableAccess();
	}

	function preview ($conn="", $lecture_id) {
//		$lecture_event_object = new CEventsInLecture();
		$this->conn = $conn;
		$this->lecture_id = $lecture_id;
		$current_event = "";
		$lec_status = "";
		$lecture_object = $this->lecture_object;
		$lecture_data = $lecture_object->getOneLecInfo($conn,$lecture_id);
		if ($lecture_data <> false) {
			$this->lecture_nam = htmlspecialchars($lecture_data["lecture_nam"],ENT_QUOTES);
			$current_event = $lecture_data["current_event"];
			$this->current_event = $current_event;
			$this->invite_key = $lecture_data["invite_key"];
			$lec_status = $lecture_data["status"];
			$this->lec_status = $lec_status;
		}

		$lecture_event_object = $this->event_link_object;
//		if ($lecture_event_object->setLectureEventLink($conn,$lecture_id)) {
		if ($lecture_event_object->setEventsPerLecArr($conn,$lecture_id)) {
		$material_object = new CMaterialTableAccess();

			$sub_frame = array();
			$main_frame = "";
			while ($res = $lecture_event_object->dbFetchArr()) {
				$event_link_id = $res["event_link_id"];
				//$lecture_nam = $res["lecture_nam"];
				$event_id = $res["event_id"];
				//$current_event = $res["current_event"];

				$content = "";

				if ($res["event_type"] == 1) {
					//
					$material_data = $material_object->getDetailMat($conn,$event_id);
					if ($material_data == false) {
						$content = "<font color='red'>Failed to Search for Material Data</font>";
					} else {
						$content .= "<h3>".htmlspecialchars($material_data["material_title"],ENT_QUOTES)."</h3>";

						$url = htmlspecialchars($material_data["material_url"],ENT_QUOTES);
						if (mb_eregi("\.ppt|\.pptx|\.odp|\.pdf|\.doc|\.docx|\.odt|\.xsl|\.ppsx|\.sldx$",$url)){
							$url = "http://docs.google.com/gview?url=".$url."&embedded=true";
						}
						$content .="<iframe src='".$url."' STYLE='zoom:40%' Scrolling='no'></iframe>";
					}
				} else if ($res["event_type"] == 2) {
					//
					if ($lec_status == null || $lec_status == 0) {
						//
						$content = "<iframe src='view_event.php?practice_id=".$event_id;
						$content .= "' STYLE='zoom:40%' Scrolling='no'></iframe>";
					} else {

					}
				} else if ($res["event_type"] == 3) {
					//ɼ
					if ($lec_status == null || $lec_status == 0) {
						//
						$content = "<iframe src='view_event.php?vote_id=".$event_id;
						$content .= "' STYLE='zoom:40%' Scrolling='no'></iframe>";
					} else {

					}
				} else if ($res["event_type"] == 4) {
					if ($lec_status == null || $lec_status == 0) {
						$content = "<iframe src='view_event.php?quiz_id=".$event_id;
						$content .= "' STYLE='zoom:40%' Scrolling='no'></iframe>";
					} else {

					}
				}

				if ($current_event == $res["event_link_id"]) {
					$main_frame = str_replace("zoom:40%","zoom:100%",$content);
					$main_frame = str_replace("no'","yes' width='100%' height='95%'",$main_frame);

				}
				$sub_frame[$res["event_link_id"]] = $content;
			}
			$lecture_event_object->dbFreeResult();

			//$this->lecture_nam = htmlspecialchars($lecture_nam,ENT_QUOTES);
			$this->main_frame = $main_frame;
			$this->sub_frame = $sub_frame;
		}
	}

	function main($conn = "", $lecture_id) {
		$this->conn = $conn;
		$this->lecture_id = $lecture_id;
		$current_event = "";
		$lec_status = "";
		$event_link_csv= "";
		$lecture_object = $this->lecture_object;

		$lecture_data = $lecture_object->getOneLecInfo($conn,$lecture_id);
		if ($lecture_data <> false) {
			$this->lecture_nam = htmlspecialchars($lecture_data["lecture_nam"],ENT_QUOTES);
			$current_event = $lecture_data["current_event"];
			$this->current_event = $current_event;
			$this->invite_key = $lecture_data["invite_key"];
			$lec_status = $lecture_data["status"];
			$this->lec_status = $lec_status;
			$this->pres_key = $lecture_data["pres_key"];
			$this->pres_type = $lecture_data["pres_type"];
		}

		$lecture_event_object = $this->event_link_object;
		if ($lecture_event_object->setEventsPerLecArr($conn,$lecture_id)) {
			$material_object = new CMaterialTableAccess();

			$sub_frame = array();
			$main_frame = "";

			while ($res = $lecture_event_object->dbFetchArr()) {
				$event_link_id = $res["event_link_id"];
				//$lecture_nam = $res["lecture_nam"];
				$event_id = $res["event_id"];
				//$current_event = $res["current_event"];

				$content = "";
				$content2 = "";
				$event_link_csv .= $event_link_id.",";

				if ($res["event_type"] == 1) {
					//
					$material_data = $material_object->getDetailMat($conn,$event_id);
					if ($material_data == false) {
						$content = "<font color='red'>Failed to Search for Material Data</font>";
					} else {
						$content .= "<h3>".htmlspecialchars($material_data["material_title"],ENT_QUOTES)."</h3>";

						$url = htmlspecialchars($material_data["material_url"],ENT_QUOTES);
						if (mb_eregi("\.ppt|\.pptx|\.odp|\.pdf|\.doc|\.docx|\.odt|\.xsl|\.ppsx|\.sldx$",$url)){
							$url = "http://docs.google.com/gview?url=".$url."&embedded=true";
						}
						$content .="<iframe src='".$url."' STYLE='zoom:40%' Scrolling='no'></iframe>";
					}
				} else if ($res["event_type"] == 2) {
					//
						$content = "<iframe src='view_event.php?practice_id=".$event_id;
						$content .= "' STYLE='zoom:40%' Scrolling='no'></iframe>";

				} else if ($res["event_type"] == 3) {
					//ɼ
					$content = "<iframe src='view_event.php?vote_id=".$event_id;
					$content .= "' STYLE='zoom:40%' Scrolling='no'></iframe>";
				} else if ($res["event_type"] == 4) {
					//ƥ
					$content = "<iframe src='view_event.php?quiz_id=".$event_id;
					$content .= "' STYLE='zoom:40%' Scrolling='no'></iframe>";
				}

				$content2 = str_replace("zoom:40%","zoom:100%",$content);
				$content2 = str_replace("no'","yes' width='100%' height='95%'",$content2);
				if ($lec_status <> null && $lec_status <> 0) {
					$content2 = str_replace("view_event.php?",
						"now_event.php?event_link_id=".$event_link_id."&status=".$res["status"]."&",
					$content2);
				}

				//$content2 = "<div id='mainf_".$event_link_id."' style='display:none'>".$content2."</div>";
				$content2 = "<span id='mainf_".$event_link_id."' style='display:none'>".$content2."</span>";

				$main_frame .= $content2;

				$sub_frame[$res["event_link_id"]] = $content;
			}
			$lecture_event_object->dbFreeResult();
			$event_link_csv = substr($event_link_csv,0,-1);
			$this->event_link_csv = $event_link_csv;

			$this->main_frame = $main_frame;
			$this->sub_frame = $sub_frame;

		}
	}

	function getEventLinkCsv () {
		return $this->event_link_csv;
	}

	function switchMainFrame ($event_link_id) {
		$sub_frame = $this->sub_frame;
		$main_frame = str_replace("zoom:40%","zoom:100%",$sub_frame[$event_link_id]);
		$main_frame = str_replace("no'","yes' width='100%' height='95%'",$main_frame);
		$this->main_frame = $main_frame;
	}

	function getMainFrame () {
		return $this->main_frame;
	}

	function getSubFrame () {
		return $this->sub_frame;
	}

	function getLectureNam (){
		return $this->lecture_nam;
	}

	function getLecStatus () {
		return $this->lec_status;
	}

	function getPresKey () {
		return $this->pres_key;
	}
	function getPresType () {
		return $this->pres_type;
	}
}

class CUseLectureFrame extends CMakeLectureFrame {
	function CUseLectureFrame () {
		$this->CMakeLectureFrame();
	}
	function startInvite () {
		$conn = $this->conn;
		$lecture_id = $this->lecture_id;
		$event_link_object = $this->event_link_object;
		$lecture_object = $this->lecture_object;
		$invite_key = rand(0,9999);
		$this->invite_key = $invite_key;
		if ($lecture_object->inviteStart($conn,$lecture_id,$invite_key)) {
			return true;
		}

		if ($lecture_object->upDat("status=1",
			"lecture_id = '".$lecture_object->escapeSqlString($lecture_id)."'",
		$conn)) {
			return false;
		}
		return false;
	}

	function getInviteKey () {
		return $this->invite_key;
	}

	function setMainFrame ($event_link_id) {
		if (!is_numeric($event_link_id)) {
			$this->err_msg = "Irregular Parameter EventLink<br/>";
			return false;
		}
		$conn = $this->conn;
		$lecture_id = $this->lecture_id;
		$lecture_object = $this->lecture_object;
		if (!$lecture_object->setCurrentEvent($conn, $lecture_id,$event_link_id)) {
			$this->err_msg = "Failed to Set Event<br/>";
			return false;
		}
		$this->setMainFrame($event_link_id);
		return true;
	}

	function startLecture () {
		$conn = $this->conn;
		$lecture_id = $this->lecture_id;
		$lecture_object = $this->lecture_object;
		$event_link_object = $this->event_link_object;

		if (!$lecture_object->startLec($conn, $lecture_id)) {
			$this->err_msg = "Failed to Start Lecture<br/>";
			return false;
		}

		if (!$lecture_object->upDat("status=1",
			"lecture_id = '".$lecture_object->escapeSqlString($lecture_id)."'",
		$conn)) {
			return false;
		}
		return true;
	}

	function endLecture () {
		$conn = $this->conn;
		$lecture_id = $this->lecture_id;
		$lecture_object = $this->lecture_object;
		$event_link_object = $this->event_link_object;

		if (!$lecture_object->endLec($conn, $lecture_id)) {
			$this->err_msg = "Failed to End Lecture<br/>";
			return false;
		}

		if (!$lecture_object->upDat("status=2",
			"lecture_id = '".$lecture_object->escapeSqlString($lecture_id)."'",
		$conn)) {
			return false;
		}

		return true;
	}
}

class CUseAfterLecture extends CUseLectureFrame {
	function CUseAfterLecture(){
		$this->CUseLectureFrame();
	}
	function setFramesAfterLec ($conn, $lecture_id, $student_id) {
		$this->conn = $conn;
		$this->lecture_id = $lecture_id;
		$current_event = "";
		$lec_status = "";
		$event_link_csv= "";
		$lecture_object = $this->lecture_object;

		$lecture_data = $lecture_object->getOneLecInfo($conn,$lecture_id);
		if ($lecture_data <> false) {
			$this->lecture_nam = htmlspecialchars($lecture_data["lecture_nam"],ENT_QUOTES);
			$current_event = $lecture_data["current_event"];
			$this->current_event = $current_event;
			$this->invite_key = $lecture_data["invite_key"];
			$lec_status = $lecture_data["status"];
			$this->lec_status = $lec_status;
		}

		$lecture_event_object = $this->event_link_object;
		if ($lecture_event_object->setEventsPerLecArr($conn,$lecture_id)) {
			$material_object = new CMaterialTableAccess();

			$sub_frame = array();
			$main_frame = "";

			while ($res = $lecture_event_object->dbFetchArr()) {
				$event_link_id = $res["event_link_id"];
				//$lecture_nam = $res["lecture_nam"];
				$event_id = $res["event_id"];
				//$current_event = $res["current_event"];

				$content = "";
				$content2 = "";
				$event_link_csv .= $event_link_id.",";

				if ($res["event_type"] == 1) {
					//
					$material_data = $material_object->getDetailMat($conn,$event_id);
					if ($material_data == false) {
						$content = "<font color='red'>Failed to Search for Material Data</font>";
					} else {
						$content .= "<h3>".htmlspecialchars($material_data["material_title"],ENT_QUOTES)."</h3>";

						$url = htmlspecialchars($material_data["material_url"],ENT_QUOTES);
						if (mb_ereg("\.ppt|\.pptx|\.odp|\.pdf|\.doc|\.docx|\.odt|\.xsl|\.ppsx|\.sldx$",$url)){
							$url = "http://docs.google.com/gview?url=".$url."&embedded=true";
						}
						$content .="<iframe src='".$url."' STYLE='zoom:40%' Scrolling='no'></iframe>";
					}
				} else if ($res["event_type"] == 2) {
					//
						$content = "<iframe src='view_event.php?event_link_id=".$event_link_id."&practice_id=".$event_id;
						$content .= "&uid=".$student_id."' STYLE='zoom:40%' Scrolling='no'></iframe>";

				} else if ($res["event_type"] == 3) {
					//ɼ
					$content = "<iframe src='view_event.php?event_link_id=".$event_link_id."&vote_id=".$event_id;
					$content .= "&uid=".$student_id."' STYLE='zoom:40%' Scrolling='no'></iframe>";
				} else if ($res["event_type"] == 4) {
					//ƥ
					$content = "<iframe src='view_event.php?event_link_id=".$event_link_id."&quiz_id=".$event_id;
					$content .= "&uid=".$student_id."' STYLE='zoom:40%' Scrolling='no'></iframe>";
				}

				$content2 = str_replace("zoom:40%","zoom:100%",$content);
				$content2 = str_replace("no'","yes' width='100%' height='450'",$content2);


				//$content2 = "<div id='mainf_".$event_link_id."' style='display:none'>".$content2."</div>";
				$content2 = "<span id='mainf_".$event_link_id."' style='display:none'>".$content2."</span>";
				$main_frame .= $content2;

				if ($res["event_type"] == 2) {
					//Ǥ褦ˤ
					$content .= "<br/><a href='do_one_prac.php?prac_id=".$event_id."' target='_blank'>"._NORM_USER_PRAC_AGAIN."</a>";
				}

				$sub_frame[$res["event_link_id"]] = $content;
			}

			//ϥեȤ߹
			$main_frame .= "<div id='comment_form' style='display:none'>";
			$main_frame .= "<iframe src='comment_form.php?lecture_id=".$lecture_id."' STYLE='zoom:100%' Scrolling='yes' width='100%' height='450'></iframe></div>";

			$lecture_event_object->dbFreeResult();
			$event_link_csv = substr($event_link_csv,0,-1);
			$this->event_link_csv = $event_link_csv;

			$this->main_frame = $main_frame;
			$this->sub_frame = $sub_frame;

		}
	}
}

class CLectureForStudent {
	var $event_frame="";
	var $note_list = "";
	var $conn = null;
	var $student_lec_object = null;
	var $current_event="";
	var $refresh_link="";
	var $lecture_id = "";
	var $lecture_nam = "";
	var $dep_id = "";
	var $lec_status;
	var $quiz_session = array();
	var $session_noneed = 0;

	function CLectureForStudent () {

	}

	function setFrameAndList ($conn, $lecture_id, $uid,$mob_id) {
		$this->conn = $conn;
		$current_event="";
		$event_type = "";
		$event_id = "";
		$event_link_id = "";
		$lecture_nam = "";
		$lec_status = "";
		$refresh_link = "<a href ='index.php?lecture_id=".intval($lecture_id);
		if ($mob_id <> "") $refresh_link .= "&guid=ON";
		$refresh_link .= "'>";

		$refresh_link .= _NORM_USER_REFRESH_TXT."</a><p/>";

		$this->refresh_link = $refresh_link;
		$this->lecture_id = $lecture_id;

		$this->student_lec_object = new CStudentInLecture();
		if ($this->student_lec_object->setCurrentLectureEvent($conn, $lecture_id)) {
			if ($res = $this->student_lec_object->dbFetchArr()) {
				$current_event = $res["current_event"];
				$event_type = $res["event_type"];
				$event_id = $res["event_id"];
				$lecture_nam = $res["lecture_nam"];
				$lec_status = $res["status"];
				$this->lec_status = $lec_status;
				//echo $this->lec_status;
			} else {
				return false;
			}
			$this->student_lec_object->dbFreeResult();
		} else {
			return false;
		}
		if ($event_type == 1) {
			if (!$this->setMaterialEventFrame($event_id, $mob_id)) {
				return false;
			}
		} else if ($event_type==2){
			if (!$this->setPracticeEventFrame($event_id,$current_event,$uid,$mob_id)){
				return false;
			}
		} else if ($event_type == 3) {
			if (!$this->setVoteEventFrame($event_id, $current_event, $uid, $mob_id)) {
				return false;
			}
		} else if ($event_type == 4) {
			if (!$this->setQuizEventFrame($event_id,$current_event,$uid,$mob_id)) {
				return false;
			}
		}else {
			return false;
		}
		$this->current_event = $current_event;
		$this->lecture_nam = encodeForUser($lecture_nam);
		$this->setNoteList($current_event,$uid,$mob_id);

		return true;
	}

	function setNoteList ($event_link, $uid,$mob_id) {
		$note_list = "";
		$note_object = new CNoteTableAccess();

		if ($note_object->setNoteListInLec($this->conn, $event_link,$uid)) {
			while ($res = $note_object->dbFetchArr()) {
				$note_list .= nl2br(encodeForUser($res["note_text"]));
				$note_list .= "<font color='grey'>(".substr($res["create_time"],0,16).")</font>";
				$note_list .= "<br/><a href='note_form.php?note_id=".$res["note_id"]."&event_link=";
				$note_list .= $this->current_event."&lecture_nam=".urlencode($this->lecture_nam);
				if ($mob_id <> "") $note_list.= "&guid=ON";

				$note_list .="#note_".$res["note_id"]."'>";
				$note_list .= _NORM_USER_NOTE_EDIT_LINK."</a><p/><hr/>";
			}
			$note_object->dbFreeResult();
		}
		$this->note_list = $note_list;
	}

	function setMaterialEventFrame ($event_id, $mob_id="") {
		$event_frame = "";

		$material_object = new CMaterialTableAccess();
		$material_data = $material_object->getDetailMat($this->conn,$event_id);
		if ($material_data == false) {
			return false;
		} else {
			$event_frame .= "<h3>".encodeForUser($material_data["material_title"])."</h3>";
			if ($mob_id == "")  {
				$url = encodeForUser($material_data["material_url"]);
				if (mb_eregi("\.ppt|\.pptx|\.odp|\.pdf|\.doc|\.docx|\.odt|\.xsl|\.ppsx|\.sldx$",$url)){
					$url = "http://docs.google.com/gview?url=".$url."&embedded=true";
				}
				$event_frame .="<iframe src='".$url."' STYLE='zoom:60%' Scrolling='yes'></iframe>";
				if (mb_eregi("\.gif|\.png|\.jpg|\.jpeg|\.tif|\.bmp$",$url)) {
					$event_frame = "<h3>".encodeForUser($material_data["material_title"])."</h3>";
					$event_frame .="<img src='".$url."' width=300 height=200/>";
				}
			}
		}
		$this->event_frame = $event_frame;
		return true;
	}

	function setPracticeEventFrame ($event_id, $event_link, $uid, $mob_id="") {
		$event_frame = "";
		$submit_arr = array();

		//桼βǡ
		$lec_prac_ans_object = new CLecpraAnsTableAccess();
		if ($lec_prac_ans_object->setPersonalAns($this->conn,$event_link,$uid)) {
			if ($res = $lec_prac_ans_object->dbFetchArr()) {
				$submit_arr = $res;
			}
			$lec_prac_ans_object->dbFreeResult();
		}

		if (!$this->student_lec_object->setPracAndLink($this->conn, $event_link)) {
			return false;
		} else {
			if ($res = $this->student_lec_object->dbFetchArr()) {
				$ans_type = $res["answer"];
				$pra_status = $res["status"];
				if ($pra_status == 1) {
					if (count($submit_arr) <> 0) {
					//кѤ
						$event_frame = "<h2>"._NORM_USER_ALREADY_SUBMIT."</h2>";

						//$event_frame .= "<a href='index.php?lecture_id=".intval($this->lecture_id);
						//$event_frame .= "'>"._NORM_USER_REFRESH_AFTER_SUB."</a><br/>";
						$refresh_link = $this->refresh_link;
						$refresh_link =str_replace(_NORM_USER_REFRESH_TXT,_NORM_USER_REFRESH_AFTER_SUB,$refresh_link);
						$this->refresh_link = $refresh_link;
						$this->event_frame = $event_frame;
						return true;
					}
					$event_frame .= "<form action='prac_reg.php' method='post'>";
				}

				$this->refresh_link = "";
				if ($pra_status == 2) {
					$refresh_link = "<a href='index.php?lecture_id=".intval($this->lecture_id);
					$refresh_link .= "'>"._NORM_USER_REFRESH_AFTER_COMMENT."</a><p/>";
					$this->refresh_link = $refresh_link;
				}
				$event_frame .= "<h2>".encodeForUser($res["practice_title"])."</h2>";
				$event_frame .= "<p/>".source2Html($res["practice_text"])."<p/>";
				$event_frame .= "<input type='hidden' name='practice_id' value='".intval($event_id)."'/>";
				$event_frame .= "<input type='hidden' name='ans_type' value='".intval($res["answer"])."'/>";
				$event_frame .= "<input type='hidden' name='department' value='".intval($res["department"])."'/>";

				$img_view = "";
				if ($res["img_file"] <> "") {
					//$img_view = "<img src='". LOCAL_URL."img_files/prac_";
					$img_view = "<img src='". IMG_URL."prac_";
					$img_view .= $event_id."/".$res['img_file']."'";
					if ($mob_id <> "") {
						$img_view .= " width=200 height=150";
					} else {
						$img_view .= " width=300 height=200";
					}
					$img_view .="/><br/><br/>";
				}
				$event_frame .= $img_view;
				if ($res["answer"] == 0 || $res["answer"] == 5) {
					//Ҽ
					$event_frame .= "<input type='text' name='answered' size=50 />";
				} else if ($res["answer"] == 1 || $res["answer"] == 2) {
					//
					$prac_item_object = new CPracItemTableAccess();
					if ($prac_item_object->setItemPerPracticeArr($this->conn, $event_id)) {
						while ($prac_item = $prac_item_object->dbFetchArr()) {
							if ($res["answer"] == 1) {
								$event_frame .= "<input type='radio' name='answered' value='";
								$event_frame .= $prac_item["item_order"]."'/>";
							} else {
								$event_frame .= "<input type='checkbox' name='answered[]' value='";
								$event_frame .= $prac_item["item_order"]."'/>";
							}
							$event_frame .= "<b>".$prac_item["item_order"]."</b> ";
							$event_frame .= source2Html($prac_item["item_txt"]);
							if ($prac_item['is_right']==1 && $pra_status == 2) {
								$event_frame .= _EXAM_COMMON_ANALYZE_RIGHT_ANS_TXT;
							}
							$event_frame .= "<br/>";
						}
						$prac_item_object->dbFreeResult();
					}
				}
				if ($pra_status == 1) {
					$event_frame .= "<input type='hidden' name='input_flag' value='1'/>";
					$event_frame .= "<input type='hidden' name='event_link' value='";
					$event_frame .= htmlspecialchars($event_link,ENT_QUOTES)."'/>";
					$event_frame .= "<input type='hidden' name='start_time' value='".time()."' />";
					$event_frame .= "<input type='hidden' name='lecture_id' value='".$this->lecture_id."' />";
					$event_frame .= "<input type='submit' value='"._NORM_USER_SUBMIT_FORM."'>";

				} else if ($pra_status == 2) {
					$your_answer = "No data";
					if (isset ($submit_arr["answer"])) {
						$your_answer = htmlspecialchars($submit_arr["answer"],3);
					}
					$event_frame .= "<p/>"._EXAM_COMMON_ANALYZE_YOUR_ANS_TXT.":".$your_answer;

					if (isset($submit_arr["is_right"]) && $submit_arr["is_right"] == 1) {
						$event_frame .= " "._NORM_USER_YOUR_ANS_OK;
					} else {
						$event_frame .= " "._NORM_USER_YOUR_ANS_NG;
					}
					$event_frame .="<p/>"._NORM_COMMON_LECTURE_COMMENT."<br/>".source2Html($res["comment"]);
				}

			}
			$this->student_lec_object->dbFreeResult();
		}
		$this->event_frame = $event_frame;
		return true;
	}

	function setVoteEventFrame ($event_id, $event_link, $uid, $mob_id="") {
		$event_frame = "";

		$submit_arr = array();

		//桼βǡ
		$lec_vote_ans_object = new CVoteAnsTableAccess();
		if ($lec_vote_ans_object->setPersonalAns($this->conn,$event_link,$uid)) {
			if ($res = $lec_vote_ans_object->dbFetchArr()) {
				$submit_arr = $res;
			}
			$lec_vote_ans_object->dbFreeResult();
		}

		if (!$this->student_lec_object->setVoteAndLink($this->conn, $event_link)) {
			return false;
		} else {
			if ($res = $this->student_lec_object->dbFetchArr()) {
				$ans_type = $res["answer"];
				$pra_status = $res["status"];
				if ($pra_status == 1) {
					if (count($submit_arr) <> 0) {
					//кѤ
						$event_frame = "<h2>"._NORM_USER_ALREADY_SUBMIT."</h2>";
						//$event_frame .= "<a href='index.php?lecture_id=".intval($this->lecture_id);
						//$event_frame .= "'>"._NORM_USER_REFRESH_AFTER_SUB."</a><br/>";

						$refresh_link = $this->refresh_link;
						$refresh_link =str_replace(_NORM_USER_REFRESH_TXT,_NORM_USER_REFRESH_AFTER_SUB,$refresh_link);
						$this->refresh_link = $refresh_link;

						$this->event_frame = $event_frame;
						return true;
					}
					$event_frame .= "<form action='vote_reg.php' method='post'>";
				}

				$this->refresh_link = "";
				if ($pra_status == 2) {
					$refresh_link = "<a href='index.php?lecture_id=".intval($this->lecture_id);
					$refresh_link .= "'>"._NORM_USER_REFRESH_AFTER_COMMENT."</a><p/>";
					$this->refresh_link = $refresh_link;
				}
				$event_frame .= "<h2>".encodeForUser($res["vote_title"])."</h2>";

				$event_frame .= "<p/>".source2Html($res["vote_text"])."<p/>";
				$event_frame .="<input type='hidden' name='vote_id' value='".intval($event_id)."'/>";
				$event_frame .= "<input type='hidden' name='ans_type' value='".intval($res["answer"])."'/>";

				$img_view = "";
				if ($res["img_url"] <> "") {
					$img_view = "<img src='". encodeForUser($res['img_url'])."'";
					if ($mob_id <> "") {
						$img_view .= " width=200 height=150";
					} else {
						$img_view .= " width=300 height=200";
					}
					$img_view .="/><br/><br/>";
				}
				$event_frame .= $img_view;
				if ($res["answer"] == 0 || $res["answer"] == 5) {
					//Ҽ
					$event_frame .= "<input type='text' name='answered' size=50 />";
				} else if ($res["answer"] == 1 || $res["answer"] == 2) {
					//
					$vote_item_object = new CVoteItemTableAccess();
					if ($vote_item_object->setItemPerVoteArr($this->conn, $event_id)) {
						while ($prac_item = $vote_item_object->dbFetchArr()) {
							if ($res["answer"] == 1) {
								$event_frame .= "<input type='radio' name='answered' value='";
								$event_frame .= $prac_item["item_order"]."'/>";
							} else {
								$event_frame .= "<input type='checkbox' name='answered[]' value='";
								$event_frame .= $prac_item["item_order"]."'/>";
							}
							$event_frame .= "<b>".$prac_item["item_order"]."</b> ";
							$event_frame .= source2Html($prac_item["item_txt"]);

							$event_frame .= "<br/>";
						}
						$vote_item_object->dbFreeResult();
					}
				}
				if ($pra_status == 1) {
					$event_frame .= "<input type='hidden' name='input_flag' value='1'/>";
					$event_frame .= "<input type='hidden' name='event_link' value='";
					$event_frame .= encodeForUser($event_link)."'/>";
					$event_frame .= "<input type='hidden' name='lecture_id' value='".$this->lecture_id."' />";
					$event_frame .= "<input type='submit' value='"._NORM_USER_SUBMIT_FORM."'>";

				} else if ($pra_status == 2) {
					$event_frame .= "<p/>"._EXAM_COMMON_ANALYZE_YOUR_ANS_TXT.":".encodeForUser($submit_arr["answer"]);
					$event_frame .="<p/>"._NORM_COMMON_LECTURE_COMMENT."<br/>".source2Html($res["vote_comment"]);
				}

			}
			$this->student_lec_object->dbFreeResult();
		}
		$this->event_frame = $event_frame;
		return true;
	}
/*
	function setQuizSession ($quiz_session) {
		$this->quiz_session = $quiz_session;
	}
*/
	function setQuizEventFrame ($event_id, $event_link, $uid,$mob_id) {
		//$quiz_session = $this->quiz_session;
		$event_frame = "";
		$status = "";

		$quiz_result_object = new CQuizResultTableAccess();
		$attempt_object = new CQuizAttemptTableAccess();
		$attempt_arr = array();
		if ($attempt_object->setPersonalAns($this->conn,$event_link,$uid)) {
			while ($res = $attempt_object->dbFetchArr()) {
				$attempt_arr[$res["quiz_prac_link_id"]] = $res;
			}
			$attempt_object->dbFreeResult();
		}

		if ($this->student_lec_object->setQuizAndLink($this->conn, $event_link)) {
			if ($res = $this->student_lec_object->dbFetchArr()) {
				$event_frame .= htmlspecialchars($res["quiz_nam"],3);
				$event_frame .= "<p/>";
				$status = $res["status"];
				if ($status == 2) {
					$event_frame .= _NORM_COMMON_LECTURE_COMMENT."<br/>";
					$event_frame .= nl2br(htmlspecialchars($res["comment"],3));
					$event_frame .= "<p/>";
				} else {
					if (count($attempt_arr) > 0) {
						$event_frame = "<h2>"._NORM_USER_ALREADY_SUBMIT."</h2>";
						$refresh_link = $this->refresh_link;
						$refresh_link =str_replace(_NORM_USER_REFRESH_TXT,_NORM_USER_REFRESH_AFTER_SUB,$refresh_link);
						$this->refresh_link = $refresh_link;
						$this->event_frame = $event_frame;
						return true;
					}

					//եФǤ褦ˤ
					$event_frame .= "<form method='post' action='quiz_reg.php'>";
					$event_frame .= "<input type='hidden' name='lecture_id' ";
					$event_frame .= " value='".$this->lecture_id."'/>";
					$event_frame .= "<input type='hidden' name='input_flag' ";
					$event_frame .= "value='1'/>";
					$event_frame .= "<input type='hidden' name='event_link' ";
					$event_frame .= " value='".$event_link."'/>";
					$event_frame .= "<input type='hidden' name='quiz_id' ";
					$event_frame .= " value='".$event_id."'/>";

				}
			}
			$this->student_lec_object->dbFreeResult();
		} else {
			return false;
		}

		if ($status == 2) {
			$event_frame .= "<h2>";
			$yr_data = $quiz_result_object->getYourResult($this->conn,$uid,$event_link);
			if ($yr_data == false) {
				$event_frame .= "No Data";
			} else {
				$event_frame .= _NORM_USER_YOUR_ANS_SCORE1;
				$event_frame .= $yr_data["score"];
				$event_frame .= _NORM_USER_YOUR_ANS_SCORE2;
			}
			$event_frame .= "</h2><br/>";
		}

		if ($this->student_lec_object->setQuizAndPra($this->conn,$event_id)) {
			while ($res = $this->student_lec_object->dbFetchArr()){
				/*
				if ($status == 1 && !isset($quiz_session[$res["practice_id"]])) {
					//ưǤĤǤ˲ѤΥå
					$tmp_arr= array();
					$tmp_arr["quiz_practice_link_id"] = $res["quiz_practice_link_id"];
					$tmp_arr["is_right"] = 0;
					$tmp_arr["answer_txt"] = "";
					$tmp_arr["score"] = intval($res["score"]);
					$tmp_arr["duration"] = 0;
					$tmp_arr["department"] = "";
					$quiz_session[$res["practice_id"]] = $tmp_arr;
				}
				// else {

				//}
				 */
				$qp_link_id = $res["quiz_prac_link_id"];
				$event_frame .= "<b>".htmlspecialchars($res["quiz_order"],3)."</b> ";
				$event_frame .= "<input type='hidden' name='practice_id[]'";
				$event_frame .= " value='".$res["practice_id"]."'/>";
				$event_frame .= "<input type='hidden' name='quiz_prac_link_id[]'";
				$event_frame .= " value='".$qp_link_id."'/>";
				$event_frame .= "<input type='hidden' name='ans_type[]'";
				$event_frame .= " value='".$res["answer"]."'/>";
				$event_frame .= "<input type='hidden' name='score[]'";
				$event_frame .= " value='".$res["score"]."'/>";
				$event_frame .= "<input type='hidden' name='dep_id[]'";
				$event_frame .= " value='".$res["department"]."'/>";

				/*
				$event_frame .= "<a href='quiz_form.php?pra_id=".$res["practice_id"];
				$event_frame .= "&event_link=".$event_link."&score=".$res["score"];
				$event_frame .="'>".htmlspecialchars($res["practice_title"],3)."</a> ";
				if ($status == 1) {
					$event_frame .= " <b>(";
					if ($quiz_session[$res["practice_id"]]["answer_txt"] <> "") {
						$event_frame .= _NORM_USER_QUIZ_LEC_SUBMITTED;
					} else {
						$event_frame .= _NORM_USER_QUIZ_LEC_NOTSUB;
					}
					$event_frame .= ")</b>";
				}
				$event_frame .= "<br/>";
				*/
				$event_frame .= htmlspecialchars($res["practice_title"],3)." (";
				$event_frame .= _EXAM_TEA_TEST_QUEST_FORM_RATIO_TXT.":".$res["score"].")<br/>";

				$event_frame .= source2Html($res["practice_text"])."<br/>";
				$img_view = "";
				if ($res['img_file'] <> ""){
//				$img_view = "<img src='". LOCAL_URL."img_files/prac_";
				$img_view = "<img src='". IMG_URL."prac_";
				$img_view .= intval($res['practice_id'])."/".$res['img_file']."'";
				if ($mob_id <> "") {
					$img_view .= " width=200 height=150";
				} else {
					$img_view .= " width=300 height=200";
				}
				$img_view .="/><br/><br/>";
				}
				$event_frame .= $img_view;

				if ($res["answer"] == 0 || $res["answer"] == 5) {
						//Ҽ
					if ($status ==1) {
					$event_frame .= "<input type='text' name='answered_".$res["practice_id"]."' size=50 />";
					} else {
						$event_frame .= "<h3>Key Words</h3>";
						$prac_kw_object = new CPracKeyWordTableAccess();
						if ($prac_kw_object->setKeyWordPerPracticeArr(
								$this->conn, $res["practice_id"])) {
							while ($kw_data = $prac_kw_object->dbFetchArr()) {
								$event_frame .= htmlspecialchars($kw_data["key_word_txt"],3).",";
							}
							$prac_kw_object->dbFreeResult();
						}
					}
				} else if ($res["answer"] == 1 || $res["answer"] == 2) {
						//
					$prac_item_object = new CPracItemTableAccess();
					if ($prac_item_object->setItemPerPracticeArr($this->conn, $res["practice_id"])) {
						while ($prac_item = $prac_item_object->dbFetchArr()) {
							if ($res["answer"] == 1) {
								$event_frame .= "<input type='radio' name='answered_".$res["practice_id"]."' value='";
								$event_frame .= $prac_item["item_order"]."'/>";
							} else {
								$event_frame .= "<input type='checkbox' name='answered_".$res["practice_id"]."[]' value='";
								$event_frame .= $prac_item["item_order"]."'/>";
							}
							$event_frame .= "<b>".$prac_item["item_order"]."</b>";
							$event_frame .= source2Html($prac_item["item_txt"]);

							if ($prac_item['is_right']==1 && $status == 2) {
								$event_frame .= _EXAM_COMMON_ANALYZE_RIGHT_ANS_TXT;
							}
							$event_frame .= "<br/>";
						}
						$prac_item_object->dbFreeResult();
					}
				}
				if ($status == 2) {
					$event_frame .= "<br/>"._EXAM_STU_PRACTICE_QUE_COMMENT;
					$event_frame .= "<br/>".source2Html($res["comment"])."<br/>";
					$event_frame .= "<hr size = '1' width='80%' align='center'/>";
					$event_frame .= "<br/>";
					$event_frame .= _EXAM_STU_PRACTICE_YOUR_ANS.":";
					$event_frame .=htmlspecialchars($attempt_arr[$qp_link_id]["ans_txt"],3);
					$event_frame .= "<br/>";
				}
				$event_frame .= "<hr size = '3'/>";
			}
			$this->student_lec_object->dbFreeResult();
			if ($status == 1) {
				$event_frame .= "<input type='submit' value='"._EXAM_COMMON_TEST_FORM_SUBMIT."'>";
				$event_frame .= "</form>";
			}

		} else {
			return false;
		}
		//if ($status == 1) $this->setQuizSession($quiz_session);

		$this->event_frame = $event_frame;
		return true;
	}
/*
	function registQuizData ($quiz_id, $event_link,$uid) {
		$this->session_noneed = 1;
		$quiz_result_object = new CQuizResultTableAccess();
		if ($quiz_result_object->checkAlreadyRegisted($this->conn, $uid,$event_link)) {
			return true;
		}

		$quiz_arr = $this->quiz_session;
		$quiz_attempt_object = new CQuizAttemptTableAccess();
		$practice_result_object = new CPracResTableAccess();
		$total_score = 0;
		foreach ($quiz_arr as $key=>$attempt) {
			if (!$quiz_attempt_object->insertAttempt($this->conn,
				$uid, $attempt["quiz_practice_link_id"],$event_link,
				$attempt["answer_txt"],$attempt["is_right"])) {
				return false;
			}
			if (!$practice_result_object->insertPracResWithoutDur($this->conn,
					$uid,$key,$attempt["answer_txt"],
					$attempt["is_right"],$attempt["department"])) {
				return false;
			}

			if ($attempt["is_right"] == 1) $total_score += $attempt["score"];
		}

		if (!$quiz_result_object->insertQuizResult($this->conn,$uid,
				$quiz_id,$event_link,$total_score)) {
			return false;
		}
		return true;
	}

	function getSessionNoneed () {
		return $this->session_noneed;
	}
*/
	function setCurrentEventFrame () {

	}

	function getEventFrame(){
		return $this->event_frame;
	}
	function getNoteList () {
		return $this->note_list;
	}

	function getRefreshLink () {
		return $this->refresh_link;
	}
	function getCurrentEvent () {
		return $this->current_event;
	}
	function getLectureNam () {
		return $this->lecture_nam;
	}

	function getLecStatus () {
		return $this->lec_status;
	}
}

class CStudentNote {
	var $note_list = "";
	var $event_view = "";
	var $note_object = null;
	var $event_link = "";
	var $uid = "";
	var $lecture_id = "";
	var $conn;
	var $err_msg="";

	function CStudentNote () {

		$this->note_object = new CNoteTableAccess();
	}

	function setForm ($conn, $uid, $event_link, $note_id,$mob_id) {
		if ($uid == "" || !is_numeric($uid)) {
			$this->err_msg = "UID PARAMETER ERR";
			return false;
		}
		if ($event_link == "" || !is_numeric($event_link)) {
			$this->err_msg = "EVENT_LINK PARAMETER ERR";
			return false;
		}

		$this->uid = $uid;
		$this->event_link = $event_link;
		$this->conn = $conn;

		if (!$this->setEventView($mob_id)) return false;
		$this->setNoteList($note_id);
		return true;
	}

	function setEventView ($mob_id) {
		$event_view = "";
		$event_type = "";
		$event_id = "";
		$lecture_id = "";
		$event_link_object = new CEventLinkTableAccess();
		if (!$event_link_object->setOneEventLink($this->conn, $this->event_link)) {
			$this->err_msg = "Parameter Error EventLink";
			return false;
		} else {
			if ($res = $event_link_object->dbFetchArr()) {
				$event_type= $res["event_type"];
				$event_id = $res["event_id"];
				$lecture_id = $res["lecture_id"];
			}
			$event_link_object->dbFreeResult();
		}

		if ($event_type == 1) {
			//
			$mat_object = new CMaterialTableAccess();
			if (!$mat_object->setSelResult("*"," WHERE material_id=".$event_id,$this->conn)) {
				$this->err_msg = "Failed to Find Material Data";
				return false;
			} else {
				if ($res = $mat_object->dbFetchArr()) {
					$event_view = "<h3>".encodeForUser($res["material_title"])."</h3>";
					if ($mob_id == "") {
						$url = encodeForUser($res["material_url"]);
						if (mb_eregi("\.ppt|\.pptx|\.odp|\.pdf|\.doc|\.docx|\.odt|\.xsl|\.ppsx|\.sldx$",$url)){
							$url = "http://docs.google.com/gview?url=".$url."&embedded=true";
						}
						$event_view .="<iframe src='".$url."' STYLE='zoom:40%' Scrolling='no'></iframe>";
						if (mb_eregi("\.png|\.gif|\.jpeg|\.jpg|\.tif|\.bmp$",$url)){
							$event_view = "<h3>".encodeForUser($res["material_title"])."</h3>";
							$event_view .= "<img src='".$url."' width=300 height=200/>";
						}
					}
				}
				$mat_object->dbFreeResult();
			}
		} else if ($event_type == 2) {
			//
			$practice_object = new CPracTableAccess();
			$prac_data = $practice_object->getDetailPracticeData($this->conn, $event_id);
			if ($prac_data == false) {
				$this->err_msg = "Failed to Find Practice Data";
				return false;
			} else {
				$event_view .= "<h3>".encodeForUser($prac_data["practice_title"])."</h3>";
				if ($mon_id == "") {
					$event_view .= source2Html($prac_data["practice_text"]);
					$img_view = "";
					if ($prac_data["img_file"] <> "") {
						$img_view = "<img src='". IMG_URL."prac_";
						$img_view .= $event_id."/".encodeForUser($prac_data['img_file'])."'";
						if ($mob_id <> "") {
							$img_view .= " width=200 height=150";
						} else {
							$img_view .= " width=300 height=200";
						}
						$img_view .="/><br/><br/>";
					}
					$event_view .= $img_view;
				}
			}
		} else if ($event_type == 3) {
			//ɼ
			$vote_object = new CVoteTableAccess();
			$vote_data = $vote_object->getDetailVote($this->conn,$event_id);
			if ($vote_data == false) {
				$this->err_msg = "Failed to Find Vote Data";
				return false;
			}
			$event_view = "<h3>".encodeForUser($vote_data["vote_title"])."</h3>";
			if ($mob_id == "") {
				$event_view .= source2Html($vote_data["vote_text"]);
				if ($vote_data["img_url"] <> "") {
					$event_view .= "<img src='".encodeForUser($vote_data["img_url"]);
					$event_view .= "' width=300 height=200/>";
				}
			}
		}
		$this->lecture_id = $lecture_id;
		$this->event_view = $event_view;
		return true;
	}

	function setNoteList ($note_id) {
		$note_list = "";
		if ($note_id == "") {
			//note_idäƤʤῷ
			$note_list = "<form name='insert_note' method='POST' action='note_form.php'>";
			$note_list .= "<textarea name='note_text' cols=50 rows=5></textarea>";
			$note_list .= "<input type='hidden' name='act_type' value='insert'>";
			$note_list .= "<input type='hidden' name='event_link' value='".$this->event_link."'>";
			$note_list .= "<input type='hidden' name='lecture_id' value='".$this->lecture_id."'>";

			$note_list .= "<br/><input type='submit' value='"._NORM_USER_NOTE_REG_LABEL."'/>";
			$note_list .= "</form><p/><hr/>";
		}
		$note_object = new CNoteTableAccess();
		if ($note_object->setNoteListInLec($this->conn,$this->event_link,$this->uid)) {
			while ($res = $note_object->dbFetchArr()) {
				if ($res["note_id"] == $note_id) {
					$note_list .= "<a name='note_".$res["note_id"]."'></a>";
					$note_list .= "<form name='insert_note' method='POST' action='note_form.php'>";
					$note_list .= "<textarea name='note_text' cols=50 rows=5>";
					$note_list .= htmlspecialchars($res["note_text"],3);
					$note_list .="</textarea>";
					$note_list .= "<input type='hidden' name='up_note_id' value='".$note_id."'>";
					$note_list .= "<input type='hidden' name='act_type' value='update'>";
					$note_list .= "<input type='hidden' name='event_link' value='".$this->event_link."'>";
					$note_list .= "<input type='hidden' name='lecture_id' value='".$this->lecture_id."'>";
					$note_list .= "<input type='submit' value='"._NORM_USER_NOTE_REG_LABEL."'/>";
					$note_list .= "</form>";
				} else {
					$note_list .= nl2br(htmlspecialchars($res["note_text"],3));
					$note_list .= "<font color ='grey'>(";
					$note_list .= substr($res["create_time"],0,16).")</font>";
					$note_list .= "<p/><br/>";
				}
				$note_list .= "<hr/>";
			}
			$note_object->dbFreeResult();
		}
		$this->note_list = $note_list;
	}

	function getEventView () {
		return $this->event_view;
	}
	function getNoteList () {
		return $this->note_list;
	}

	function getErrMsg () {
		return $this->err_msg;
	}

	function getLectureId () {
		return $this->lecture_id;
	}
}

class CStudentNoteList {
	var $note_list = "";
	function CStudentNoteList () {

	}

	function setNoteList ($conn,$lecture_id, $uid) {
		$note_text = "";
		$pre_event_link="";
		$note_data_object = new CStudentAfterLecData();
		$material_object = new CMaterialTableAccess();
		$practice_object = new CPracTableAccess();
		$vote_object = new CVoteTableAccess();
		$quiz_object = new CQuizTableAccess();

		if ($note_data_object->setNoteInLec($conn,$lecture_id,$uid)) {
			while ($res = $note_data_object->dbFetchArr()) {
				if ($res["event_link_id"] <> $pre_event_link) {
					$note_text .= "<hr size = '3' align='center' width='90%'/>";
					$note_text .= "<a name='event_link_".$res["event_link_id"];
					$note_text .= "'/>";
					if ($res["event_type"] == 1) {
						//
						$mat_data = $material_object->getDetailMat($conn,$res["event_id"]);
						if ($mat_data == false) {
							$note_text .= "No Data<br/>";
						} else {
							$note_text .= "<h2>".htmlspecialchars($mat_data["material_title"],3)."</h2>";
						}
					} else if ($res["event_type"] == 2) {
						//
						$prac_data = $practice_object->getDetailPracticeData($conn,$res["event_id"]);

						if ($prac_data== false) {
							$note_text .= "No Data<br/>";
						} else {
							$note_text .= "<h2>".htmlspecialchars($prac_data["practice_title"],3)."</h2>";
						}
					} else if ($res["event_type"] == 3) {
						$vote_data = $vote_object->getDetailVote($conn,$res["event_id"]);
						if ($vote_data == false) {
							$note_text .= "No Data<br/>";
						} else {
							$note_text .= "<h2>".htmlspecialchars($vote_data["vote_title"],3)."</h2>";
						}
					} else if ($res["event_type"] == 4) {
						$quiz_data = $quiz_object->getDetailQuiz($conn, $res["event_id"]);
						if ($quiz_data == false) {
							$note_text .= "No Data<br/>";
						} else {
							$note_text .= "<h2>".htmlspecialchars($quiz_data["quiz_nam"],3)."</h2>";
						}
					}
/*
					$note_text .= "<font color='blue' onClick='openInsertNoteForm(".$res["event_link_id"].")'>";
					$note_text .= _NORM_USER_NOTE_REG_LABEL."</font><p/>";
					$note_text .= "<div id ='insert_form_".$res["event_link_id"]."' style='display:none'>";
					$note_text .= "<form name='insert_form' method='post' action='note_frame.php'>";
					$note_text .= "<textarea name='note_text' cols='40' rows='6'>";
					$note_text .= "</textarea>";
					$note_text .= "<input type='hidden' name='lecture_id' value='".intval($lecture_id)."'/>";
					$note_text .= "<input type='hidden' name='event_link_id' value='".$res["event_link_id"]."'/>";
					$note_text .= "<p/><input type='submit' value='"._NORM_USER_NOTE_REG_LABEL."' />";
					$note_text .= "</form>";
					$note_text .= "<font color='blue' onClick='closeInsertNoteForm(".$res["event_link_id"].")'/>";
					$note_text .= _NORM_USER_NOTE_CANCEL_LABEL."</font><p/>";
					$note_text .= "</div>";
*/
				} else {
					$note_text .= "<hr size = '1' align='center' width='80%'/>";
				}
				//̾ɽ
				$note_text .= "<div id='note_text_".$res["note_id"]."' style='display:inline'>";
				$note_text .= nl2br(htmlspecialchars($res["note_text"],3));
				$note_text .= "<font color='grey'>(".substr($res["create_time"],0,16).")</font>";
				//$note_text .= "<a href='#' onClick='openEditNoteForm(".$res["note_id"].")'>";
				//$note_text .= _NORM_USER_NOTE_EDIT_LINK."</a>";
				$note_text .= "<br/><font color='blue' onClick='openEditNoteForm(".$res["note_id"].")'>";
				$note_text .= _NORM_USER_NOTE_EDIT_LINK."</font>";

				$note_text .= "</div>";
				//եɽ
				$note_text .= "<div id ='note_form_".$res["note_id"]."' style='display:none'>";
				$note_text .= "<form name='update_form' method='post' action='note_frame.php'>";
				$note_text .= "<textarea name='note_text' cols='40' rows='6'>";
				$note_text .= htmlspecialchars($res["note_text"],3);
				$note_text .= "</textarea>";
				$note_text .= "<input type='hidden' name='note_id' value='".$res["note_id"]."'/>";
				$note_text .= "<input type='hidden' name='lecture_id' value='".intval($lecture_id)."'/>";
				$note_text .= "<input type='hidden' name='event_link_id' value='".intval($res["event_link_id"])."'/>";

				$note_text .= "<p/><input type='submit' value='"._NORM_USER_NOTE_EDIT_LINK."'/>";
				$note_text .= "<input type='button' onClick='closeEditNoteForm(".$res["note_id"].")' value='";
				$note_text .= _NORM_USER_NOTE_CANCEL_LABEL."'/>";
				$note_text .= "</form>";
				$note_text .= "</div>";

				$pre_event_link = $res["event_link_id"];
			}
			$note_data_object->dbFreeResult();
		}
		$this->note_list = $note_text;
	}

	function getNoteList () {
		return $this->note_list;
	}

}

class CQuizExecuter {
	var $quiz_form = "";
	var $quiz_object;
	var $link_object;
	var $prac_object;
	var $attempt_object;
	var $result_object;
	var $err_msg = "";
	var $prac_data_arr = array();
	var $quiz_nam = "";
	var $quiz_comment = "";

	var $result_num = 0;
	var $ave_score;
	var $sd_score;

	var $conn;

	function CQuizExecuter () {
		$this->quiz_object = new CQuizTableAccess();
		$this->link_object = new CQuizPraLinkTableAccess();
		$this->prac_object = new CPracTableAccess();
		$this->attempt_object = new CQuizAttemptTableAccess();
		$this->result_object = new CQuizResultTableAccess();
	}

	function setQuizBasicInfo ($conn, $quiz_id, $event_link_id) {
		$this->conn = $conn;
		$quiz_data = $this->quiz_object->getDetailQuiz($conn, $quiz_id);
		if ($quiz_data == false) {
			$this->err_msg = "Failed to search quiz data";
			return false;
		}
		$this->quiz_nam = htmlspecialchars($quiz_data["quiz_nam"],3);
		$this->quiz_comment = nl2br(htmlspecialchars($quiz_data["comment"],3));

		if ($this->link_object->setQuizLinkData($conn, $quiz_id)) {
			while ($res = $this->link_object->dbFetchArr()) {
				$this->setEachPracticeData(
					$res["practice_id"],$res["quiz_order"],$res["score"],
					$res["quiz_prac_link_id"]);
			}
			$this->link_object->dbFreeResult();
		}

		$this->setAttemptData($event_link_id);
		$this->setResultData($event_link_id);
		$this->setQuizForm();

	}

	function setEachPracticeData ($practice_id, $quiz_order,$score,$practice_link) {
		$prac_data_arr = $this->prac_data_arr;
		$one_prac_dat_arr = array();
		$one_prac_dat_arr["quiz_order"] = $quiz_order;
		$one_prac_dat_arr["score"] = $score;
		$one_prac_dat_arr["right_num"] = 0;
		$one_prac_dat_arr["all_num"] = 0;
		$one_prac_dat_arr["answer_txts"] = "";

		$prac_data = $this->prac_object->getDetailPracticeData($this->conn,$practice_id);
		if ($prac_data <> false) {
			$one_prac_dat_arr["practice_title"] = htmlspecialchars($prac_data["practice_title"],3);
			$one_prac_dat_arr["practice_text"] =
				source2Html($prac_data["practice_text"]);
			$one_prac_dat_arr["practice_comment"] =
				source2Html($prac_data["comment"]);
			$one_prac_dat_arr["answer"] = $prac_data["answer"];

			if ($prac_data["answer"] == 1 || $prac_data["answer"] == 2) {
				$item_arr = array();
				$item_object = new CPracItemTableAccess();
				if ($item_object->setItemPerPracticeArr($this->conn,$practice_id)) {
					while ($res = $item_object->dbFetchArr()) {
						$item_arr[$res["item_order"]]["num"] = 0;
						$item_arr[$res["item_order"]]["text"] =
							source2Html($res["item_txt"]);
						$item_arr[$res["item_order"]]["is_right"] = $res["is_right"];
					}
					$item_object->dbFreeResult();
				}
				$one_prac_dat_arr["items"]=$item_arr;
			} else {
				$key_words = array();
				$key_word_object = new CPracKeyWordTableAccess();
				if ($key_word_object->setKeyWordPerPracticeArr($this->conn,$practice_id)) {
					while ($res = $key_word_object->dbFetchArr()) {
						array_push($key_words,$res["key_word_txt"]);
					}
					$key_word_object->dbFreeResult();
				}
				$one_prac_dat_arr["key_words"] = $key_words;
			}
		}

		$prac_data_arr[$practice_link] = $one_prac_dat_arr;
		$this->prac_data_arr = $prac_data_arr;
	}

	function setAttemptData ($event_link) {
		$prac_data_arr = $this->prac_data_arr;
		$attempt_object = new CQuizAttemptTableAccess();
		if ($attempt_object->setAnswerPerEvent($this->conn, $event_link)) {
			//$score = 0;
			//$pre_uid = "";
			//$all_cnt = 0;

			while ($res = $attempt_object->dbFetchArr()) {
				/*
				if ($pre_uid <> $res["uid"]) {
					if ($pre_uid <> "") {
						$score_arr[$pre_uid] = $score;
					}
					$pre_uid = $res["uid"];
					$score = 0;
				}
				*/
				$prac_data_arr[$res["quiz_prac_link_id"]]["all_num"]++;
				if ($res["is_right"] == 1) {
					$prac_data_arr[$res["quiz_prac_link_id"]]["right_num"]++;
				}
				if ($prac_data_arr[$res["quiz_prac_link_id"]]["answer"] == 1) {
					//Ĳ
					$prac_data_arr[$res["quiz_prac_link_id"]]["items"][$res["ans_txt"]]["num"]++;
				} else if ($prac_data_arr[$res["quiz_prac_link_id"]]["answer"] == 2) {
					//ʣ
					$answers = explode(",",$res["ans_txt"]);
					foreach ($answers as $answer) {
						$prac_data_arr[$res["quiz_prac_link_id"]]["items"][$answer]["num"]++;
					}
				} else {
					//Ҽ
					$prac_data_arr[$res["quiz_prac_link_id"]]["answer_txts"]
						.= htmlspecialchars($res["ans_txt"],3)."<br/>";
				}
			}
			$attempt_object->dbFreeResult();
		}
		$this->prac_data_arr = $prac_data_arr;
	}

	function setResultData ($event_link) {

		if ($this->result_object->setDadaForAnalysis1($this->conn,$event_link)) {
			if ($res = $this->result_object->dbFetchArr()) {
				$this->result_num = $res["cnt"];
				$this->ave_score = $res["avg"];
				$this->sd_score = $res["sd"];
			}
			$this->result_object->dbFreeResult();
		}

	}

	function setQuizForm () {
		$quiz_form="";
		$prac_data_arr = $this->prac_data_arr;
		foreach ($prac_data_arr as $prac_data) {
			$quiz_form .= "<table><tr>";
			$quiz_form .= "<td valign='top'>".$prac_data["quiz_order"];
			$quiz_form .= "</td><td>".$prac_data["practice_title"];
			$quiz_form .= "<p/>".$prac_data["practice_text"]."<p/><hr/><p/>";
			$quiz_form .= "<p/>".$prac_data["practice_comment"]."<p/><hr/><p/>";
			if ($prac_data["answer"] == 1) {
				$ana_img = "<img src='https://chart.googleapis.com/chart?cht=p3&amp;chs=500x200&chd=t:";
				$ana_img2 = "";
				$item_arr = $prac_data["items"];
				foreach ($item_arr as $key=>$val) {
					$quiz_form .= "<b>";
					if ($val["is_right"] == 1) {
						$quiz_form .="("._EXAM_TEA_OPTION_RIGHT_ANS.")";
					}
					$quiz_form .= $key."</b> ";
					$quiz_form .= $val["text"]." (";
					$ans_percent = intval($val["num"])/intval($prac_data["all_num"])*100;
					$quiz_form .= $ans_percent."%)<br/>";
					$ana_img .= $ans_percent.",";
					$ana_img2 .= $key.":".$val["num"]._NORM_COMMON_LECTURE_MAL."|";

				}
				$ana_img = substr($ana_img,0,-1);
				$ana_img2 = substr($ana_img2,0,-1);
				$ana_img .= "&amp;chl=".$ana_img2."'/>";
				$quiz_form .= $ana_img;

			} else if ($prac_data["answer"] == 2) {
				$item_arr = $prac_data["items"];
				foreach ($item_arr as $key=>$val) {
					$quiz_form .= "<b>";
					if ($val["is_right"] == 1) {
						$quiz_form .="("._EXAM_TEA_OPTION_RIGHT_ANS.")";
					}
					$quiz_form .= $key."</b> ";
					$quiz_form .= $val["text"]." (";
					$ans_percent = intval($val["num"]);
					$quiz_form .= $ans_percent._NORM_COMMON_LECTURE_MAL.")<br/>";
				}
			} else {
				$quiz_form .= "<h2>Key Words</h2>";
				$key_words = $prac_data["key_words"];
				foreach ($key_words as $key_word) {
					$quiz_form .= $key_word." ";
				}
				$quiz_form .= "<p/>";
				$quiz_form .= $prac_data["answer_txts"];
			}
			$quiz_form .= "<td>"._EXAM_COMMON_PRACTICE_ANA_KAISU.":".$prac_data["all_num"];

			$quiz_form .= "<br/>".EXAM_TEA_TEST_QUEST_FORM_RATIO_TXT.":".$prac_data["score"];
			$quiz_form .="</td></tr></table>";
		}
		$this->quiz_form = $quiz_form;
	}

	function getQuizForm () {
		return $this->quiz_form;
	}
}

class QuizAnalysis extends CQuizExecuter {
	var $uid= "";
	function QuizAnalysis () {

	}

	function setUid ($uid) {
		$this->uid = $uid;
	}

	function setYourAnswer (){

	}

}

class CInviteStudent {
	var $class_student_object;
	var $gu_link_object;
	var $lecture_object;
	var $mobile_user_object;
	var $student_object;
	var $conn;
	var $lecture_id;
	var $class_id;

	var $err_msg = "";
	var $right_invite_key;
	var $student_data = array();
	var $mobile_id="";

	function CInviteStudent () {

	}

	function regist ($conn, $post_data, $class_student_object,$login_object,
			$gu_link_object, $lecture_object, $mobile_user_object,$right_invite_key) {
		$this->conn = $conn;
		$this->lecture_object = $lecture_object;
		$this->class_student_object = $class_student_object;
		$this->gu_link_object = $gu_link_object;
		$this->mobile_user_object = $mobile_user_object;
		$this->right_invite_key = $right_invite_key;
		$this->student_object = $login_object;
		if (!$this->validate($post_data)) {
			return false;
		}
		$uname = mb_convert_encoding($post_data["uname"],XOOPS_SRT_ENCODE,'UTF-8');

		$name = mb_convert_encoding($post_data["name"],XOOPS_SRT_ENCODE,'UTF-8');
		//$name = $post_data["name"];
		$pass = $post_data["passwd"];
		$email = $post_data["email"];
		$groupid = $post_data["groupid"];
		if (!$this->setStudentData($uname,$pass,$email,$name)) {
			return false;
		}
		if (!$this->insertLinkData($groupid)) {
			return false;
		}
		if ($this->mobile_id <> "" && !$this->setupMobileData()) {
			return false;
		}
		return true;
	}

	function getStudentData () {
		return $this->student_data;
	}

	function insertLinkData ($groupid) {
		//롼ץ桼󥯤ȥ饹ּԥ󥯤Ͽ
		$student_data = $this->student_data;
		$uid = $student_data["student_id"];
		$link_id = $this->gu_link_object->getLinkId($this->conn,$groupid,$uid);

		if ($link_id == 0) {
			if (!$this->gu_link_object->insertLinkExe($this->conn, $groupid, $uid)) {
				$this->err_msg .= "Failed to Insert GroupLink";
				return false;
			}
			$link_id = $this->gu_link_object->getLatestId("linkid",$this->conn);
		}

		$this->gu_link_object->insertLinkExe($this->conn, 2, $uid);
		$this->class_student_object->insDat("uid,groupid,linkid,status",
			$uid.",'".$this->class_student_object->escapeSqlString($groupid)."',".$link_id.",1",
			$this->conn);
		return true;
	}

	function setupMobileData () {
		//1:桼ID鸫Хǡˤϡ
		//1-1:ϿХȰ㤦硢Хơ֥UPDATE
		//2:ʤˤϥơ֥륤󥵡
		$student_data = $this->student_data;
		$uid = $student_data["student_id"];
		$mobile_id = $this->mobile_id;
		$registed_mob_id = "";

		if ($this->mobile_user_object->setMobileOfUser($this->conn, $uid)) {
			if ($res = $this->mobile_user_object->dbFetchArr()) {
				$registed_mob_id = $res["mobile_id"];
			}
			$this->mobile_user_object->dbFreeResult();
		}
		if ($registed_mob_id <> "") {
			//åץǡ
			if (!$this->mobile_user_object->updateMobileUserExe (
					$this->conn, $uid, $mobile_id)) {
				$this->err_msg .= "Failed to Update MobileData";
				return false;
			}
		} else {
			//󥵡
			if (!$this->mobile_user_object->insertMobileUserDataExe (
					$this->conn, $uid, $mobile_id)) {
				$this->err_msg .= "Failed to Insert MobileData";
				return false;
			}
		}
		return true;


	}

	function setMobileId ($mobile_id) {
		$this->mobile_id = $mobile_id;
	}

	function validate ($post_data) {

		//̾ϥå
		if ($post_data["uname"] == "" || $post_data["uname2"] == "" || $post_data["passwd"] == "" ||
		$post_data["passwd2"] == "" || $post_data["name"] == "" || $post_data["invite_key"] == "") {
			$this->err_msg = _NORM_USER_INVITE_EMPTY_ERR;
			return false;
		}

		if ($post_data["uname"] <> $post_data["uname2"]) {
			$this->err_msg = _NORM_USER_DIFF_UNAME_ERR;
			return false;
		}

		if (!preg_match("/^[a-zA-Z0-9]+$/", $post_data["uname"])) {
			$this->err_msg =_NORM_USER_DIFF_TYPEUNAME_ERR;
			return false;
		}

		if ($post_data["passwd"] <> $post_data["passwd2"]) {
			$this->err_msg = _NORM_USER_DIFF_PASSWD_ERR;
			return false;
		}
		if ($post_data["email"] <> $post_data["email2"]) {
			$this->err_msg = _NORM_USER_DIFF_EMAIL_ERR;
			return false;
		}

		if ($post_data["invite_key"] <> $this->right_invite_key) {
			$this->err_msg = _NORM_USER_DIFF_INVITE_ERR;
			return false;
		}
		return true;
	}

	function setStudentData ($uname, $pass, $email, $name) {
		/*
		 * 1ƱunameemailΥȤϤʤ
		 * 2:ƱunameΥȤꡢѥɤäƤ
		 * 3unameѺѤߤ
		 */
		$student_data = $this->student_object->getDataForLogin($this->conn,$uname,md5($pass));
		$err_msg = "";

		if ($student_data<> false) {
			$this->student_data = $student_data;
			return true;
		}

		if ($this->student_object->setSelResult("*",
			" WHERE uname = '".$this->student_object->escapeSqlString($uname)."'",
		$this->conn)) {
			if ($res = $this->student_object->dbFetchArr()) {
				$err_msg = _NORM_USER_UNAME_USED_ERR;
			}
			$this->student_object->dbFreeResult();
		}

		if ($this->student_object->setSelResult("*",
			" WHERE email = '".$this->student_object->escapeSqlString($email)."'",
		$this->conn)) {
			if ($res = $this->student_object->dbFetchArr()) {
				$err_msg .= _NORM_USER_DIFF_EMAIL_ERR;
			}
			$this->student_object->dbFreeResult();
		}

		if ($err_msg <> "") {
			$this->err_msg = $err_msg;
			return false;
		}

		if (!$this->student_object->insertXoUserExe($this->conn,$uname,$pass, $name,$email)) {
			$this->err_msg = "Failed to Insert User Data<br/>";
			return false;
		}
		$uid = $this->student_object->getLatestId("uid",$this->conn);
		$student_data = array();
		$student_data['student_nam'] = $uname;
		$student_data['student_id'] = $uid;
		$this->student_data = $student_data;

		return true;
	}

	function getErrMsg () {
		return $this->err_msg;
	}

}

class CLectureEnder {
	//ֵλ륯饹
	var $lecture_object;
	var $event_link_object;
	var $err_msg="";

	function CLectureEnder () {

	}

	function getErrMsg () {
		return $this->err_msg;
	}

	function endLecture ($conn, $lecture_id) {
		//λΥᥤưBoolean
		$lecture_object = new CLectureTableAccess();
		$event_link_object = new CEventLinkTableAccess();


		if (!$lecture_object->endLec($conn,$lecture_id)) {
			$this->err_msg.="Failed to end lecture data";
			return false;
		}
		if (!$event_link_object->byEndLecture($conn,$lecture_id)) {
			$this->err_msg .= "Failed to change event status";
			return false;
		}

		if (!$this->copyBackupNote($conn, $lecture_id)) {
			return false;
		}


		$lecture_data = $lecture_object->getOneLecInfo($conn,$lecture_id);
		//if ($lecture_data["pres_type"] == 0) {
		//	return true;
		//}
		//student_id򥭡Ȥз
		$pres_set_arr = array();

		$pres_object = new CPresChecker();
		$lec_pres_object = new CLecPresTableAccess();

		if ($lecture_data["pres_type"] == 1) {
			if ($lec_pres_object->setLecPresOfLec($conn,$lecture_id)) {
				while ($res = $lec_pres_object->dbFetchArr()) {
					$pres_set_arr[$res["uid"]] = $res["status"];
				}
				$lec_pres_object->dbFreeResult();
			}

		} else if ($lecture_data["pres_type"] == 2) {
			//ΡƤˤз

			$pres_set_arr = $pres_object->getNotePres($conn,
			$event_link_object,$lecture_data["pres_note_percent"],
			$lecture_id);

		} else if ($lecture_data["pres_type"] == 3) {
			//Ψˤз
			$pres_set_arr = $pres_object->getPraRightPres($conn,
			$event_link_object,$lecture_data["pres_right_percent"],$lecture_id);

		} else if ($lecture_data["pres_type"] == 4) {
			//ȥΡȤξ
			$pres_set_arr = $pres_object->getBothPres($conn,
			$event_link_object,$lecture_data["pres_note_percent"],
			$lecture_data["pres_right_percent"],$lecture_id);

		} else if ($lecture_data["pres_type"] == 5) {
			//Ψ
			$pres_set_arr = $pres_object->getSubmitPercentPres($conn,
			$event_link_object,$lecture_data["pres_submit_percent"],$lecture_id);

		} else if ($lecture_data["pres_type"] == 6) {
			//ƥΨ
			$pres_set_arr = $pres_object->getQuizPercentPres($conn,
			$lecture_data["pres_quiz_percent"], $lecture_id);

		} else if ($lecture_data["pres_type"] == 7) {
			//ƥȤ
			$pres_set_arr = $pres_object->getQuizPracPres($conn,
			$event_link_object,$lecture_data["pres_right_percent"],$lecture_data["pres_quiz_percent"],$lecture_id);

		} else if ($lecture_data["pres_type"] == 8) {
			//ƥȡꡦΡ
			$pres_set_arr = $pres_object->getThreePres($conn,
			$event_link_object, $lecture_data["pres_right_percent"],
			$lecture_data["pres_quiz_percent"],
			$lecture_data["pres_note_percent"],$lecture_id);

		}

		$class_st_object = new CClassStudentTableAccess();
		//$lec_pres_object = new CLecPresTableAccess();
		if ($class_st_object->setStudentInClass($conn, $lecture_data["groupid"])) {
			while ($res = $class_st_object->dbFetchArr()) {
				$status = 0;
				if (isset($pres_set_arr[$res["uid"]])) {
					$status = $pres_set_arr[$res["uid"]];
				}
				//QRɤξ㳰Ǥ˥ǡäƤ롣
				if ($lecture_data["pres_type"] == 1 && $status == 1) {
					continue;
				}
				$lec_pres_object->insertLecPresExe($conn,$res["uid"],$lecture_id,$status);
			}
			$class_st_object->dbFreeResult();
		}
		return true;
	}

	function copyBackupNote ($conn, $lecture_id) {
		//ꥸʥΥΡȤΥԡȤ
		if (!is_numeric($lecture_id)) {
			$this->err_msg = "Back UP Parameter Error ";
			return false;
		}

		$sql = "INSERT INTO ".ORIGINAL_NOTE_TBL;
		$sql .= " SELECT nt.note_id, nt.student_id, nt.event_link_id,";
		$sql .= "nt.note_text, nt.create_time, nt.update_time FROM ".NOTE_TBL." AS nt, ";
		$sql .= EVENT_LINK_TBL." elt WHERE elt.event_link_id = nt.event_link_id AND";
		$sql .= " elt.lecture_id = '".$lecture_id."'";

		$table_object = new CTblAccess("");
		if (!$table_object->execute_query($sql,$conn)) {
			$this->err_msg = "Failed to Back Up";
			return false;
		}

		return true;
	}
}

class CPresChecker {
	function CPresChecker () {

	}

	function getNotePres ($conn, $event_link_object, $note_percent,$lecture_id) {
		$pres_score_arr = array();
		$total_score = 0;
		$pres_arr = array();
		$key_event_object = new CKeywordsForEventData();
		$note_object = new CNoteTableAccess();

		mb_regex_encoding("UTF-8");

		if ($event_link_object->setEventsPerLecArr($conn, $lecture_id)) {
			while($res = $event_link_object->dbFetchArr()) {
				$key_cand_arr = array();
				$key_score_arr= array();


				if ($key_event_object->setKeywordsList($conn,
				$res["event_id"],$res["event_type"])) {
					$pre_key_id = "";
					while ($res2 = $key_event_object->dbFetchArr()) {

						//Υ٥ȤΥɤ
						if ($res2["note_keyword_id"] <> $pre_key_id) {
							$total_score += $res2["score"];
							$key_score_arr[$res2["note_keyword_id"]] = $res2["score"];
						}
						if (!isset($key_cand_arr[$res2["note_keyword_id"]])){
							$key_cand_arr[$res2["note_keyword_id"]] = $res2["key_word_text"];
						} else {
							$key_cand_arr[$res2["note_keyword_id"]] .= "|".$res2["key_word_text"];
						}
						$pre_key_id = $res2["note_keyword_id"];
					}
					$key_event_object->dbFreeResult();
				}
				if (count($key_cand_arr) == 0) continue;


				$tmp_score_arr = array();
				if ($note_object->setNoteListPerEventLink($conn,$res["event_link_id"])) {
					while ($res2 = $note_object->dbFetchArr()) {
						//Υ٥ȤΥ桼ȤΥΡȤ

						if (!isset($tmp_score_arr[$res2["student_id"]])) {
							$tmp_score_arr[$res2["student_id"]] = $key_score_arr;
						}
						if (!isset($pres_score_arr[$res2["student_id"]])) {
							$pres_score_arr[$res2["student_id"]] = 0;
						}

						foreach ($key_cand_arr as $key=>$val) {
							if (!isset($tmp_score_arr[$res2["student_id"]][$key])) continue;
							if (mb_ereg($val,$res2["note_text"])) {

								$pres_score_arr[$res2["student_id"]] += $key_score_arr[$key];
								unset($tmp_score_arr[$res2["student_id"]][$key]);
							}
						}
					}
					$note_object->dbFreeResult();
				}

			}
			$event_link_object->dbFreeResult();
		}
		foreach ($pres_score_arr as $uid=>$uscore) {
			if ($total_score == 0) {
				$pres_arr[$uid] = 1;
				continue;
			}
			if ($uscore == $total_score) {
				$pres_arr[$uid] = 1;
			} else if ($uscore >= ($note_percent * $total_score /100)) {
				$pres_arr[$uid] = 2;
			} else {
				$pres_arr[$uid] = 3;
			}
		}

		return $pres_arr;
	}

	function getPraRightPres ($conn, $event_link_object, $right_percent,$lecture_id) {
		$pres_arr = array();
		$link_csv = "";
		$event_cnt = 0;
		if ($event_link_object->setEventLinkOfPracInLec($conn,$lecture_id)) {
			while ($res = $event_link_object->dbFetchArr()) {
				$link_csv .= $res["event_link_id"].",";
				$event_cnt++;
			}
			$event_link_object->dbFreeResult();
		}
		if ($link_csv == "") {
			return $pres_arr;
		}
		$link_csv = substr($link_csv,0,-1);

		$lec_prac_ans_object = new CLecpraAnsTableAccess();
		if ($lec_prac_ans_object->setRightPercentInLec($conn,$link_csv,$event_cnt)) {
			while ($res = $lec_prac_ans_object->dbFetchArr()) {
				if ($res["right_percent"] == 100) {
					$pres_arr[$res["uid"]] = 1;
				} else if ($res["right_percent"] >= $right_percent) {
					$pres_arr[$res["uid"]] = 2;
				} else {
					$pres_arr[$res["uid"]] = 3;
				}
			}
			$lec_prac_ans_object->dbFreeResult();
		}
		return $pres_arr;
	}

	function getBothPres ($conn, $event_link_object, $note_percent,
			$right_percent,$lecture_id) {
		//ΡƤΨǽзȤ

		$pres_arr = array();
		$note_arr = $this->getNotePres($conn,$event_link_object,$note_percent,$lecture_id);
		$right_arr = $this->getPraRightPres($conn,$event_link_object,$right_percent, $lecture_id);
		//ǽ˥ΡȤ˴ŤʤΨ˴Ťʤξ

		foreach ($note_arr as $uid=>$val) {
			if (!isset($right_arr[$uid])) {
				$pres_arr[$uid] =3;
				continue;
			}
			if ($val==1 && $right_arr[$uid] ==1) {
				$pres_arr[$uid] =1;
			} else if ($val<=2 && $right_arr[$uid] <=2) {
				$pres_arr[$uid] =2;
			} else {
				$pres_arr[$uid] =3;
			}
			unset($right_arr[$uid]);
		}
		//ΡȤ˽񤭹ߤʤˤϲƤΤ򽦤
		foreach ($right_arr as $uid=>$val) {
			$pres_arr[$uid] =3;
		}
		return $pres_arr;
	}

	function getSubmitPercentPres ($conn, $event_link_object, $submit_percent,$lecture_id) {
		//Ψˤ
		$pres_arr = array();
		$event_cnt = 0;
		$prac_csv="";
		$vote_csv="";
		$quiz_csv="";
		$tmp_arr = array();
		if ($event_link_object->setEventsPerLecArr($conn, $lecture_id)) {
			while ($res = $event_link_object->dbFetchArr()) {
				if ($res["event_type"] <> 1) $event_cnt++;
				if ($res["event_type"] == 2) $prac_csv .= $res["event_link_id"].",";
				if ($res["event_type"] == 3) $vote_csv .= $res["event_link_id"].",";
				if ($res["event_type"] == 4) $quiz_csv .= $res["event_link_id"].",";
			}
			$event_link_object->dbFreeResult();
		}

		if ($prac_csv <> "") {
			$prac_csv = substr($prac_csv,0,-1);
			$prac_ans_object = new CLecpraAnsTableAccess();
			if ($prac_ans_object->setPersonPracAnsInLec($conn,$prac_csv)) {
				while ($res = $prac_ans_object->dbFetchArr()) {
					if (!isset($tmp_arr[$res["uid"]])) {
						$tmp_arr[$res["uid"]] = $res["prac_cnt"];
					} else {
						$tmp_arr[$res["uid"]] += $res["prac_cnt"];
					}
				}
				$prac_ans_object->dbFreeResult();
			}

		}

		if ($vote_csv <> "") {
			$vote_csv = substr($vote_csv,0,-1);
			$vote_ans_object = new CVoteAnsTableAccess();
			if ($vote_ans_object->setPersonVoteCntInLec($conn, $vote_csv)) {
				while ($res = $vote_ans_object->dbFetchArr()) {
					if (!isset($tmp_arr[$res["uid"]])) {
						$tmp_arr[$res["uid"]] = $res["vote_cnt"];
					} else {
						$tmp_arr[$res["uid"]] += $res["vote_cnt"];
					}
				}
				$vote_ans_object->dbFreeResult();
			}
		}
		if ($quiz_csv <> "") {
			$quiz_csv = substr($quiz_csv,0,-1);
			$quiz_res_object = new CQuizResultTableAccess();
			if ($quiz_res_object->setPersonQuizInLec($conn, $quiz_csv)) {
				while ($res = $quiz_res_object->dbFetchArr()) {
					if (!isset($tmp_arr[$res["uid"]])) {
						$tmp_arr[$res["uid"]] = $res["quiz_cnt"];
					} else {
						$tmp_arr[$res["uid"]] += $res["quiz_cnt"];
					}
				}
				$quiz_res_object->dbFreeResult();
			}

		}

		foreach ($tmp_arr as $uid=>$val) {
			if ($val == $event_cnt) {
				$pres_arr[$uid] = 1;
			} else if (($val/$event_cnt*100) >= $submit_percent) {
				$pres_arr[$uid] = 2;
			} else {
				$pres_arr[$uid] = 3;
			}
		}
		return $pres_arr;
	}

	function getQuizPercentPres ($conn, $quiz_percent, $lecture_id) {
		$pres_arr = array();
		$full_score = 0;

		$quiz_in_lec_object = new CQuizInLecture();
		if ($quiz_in_lec_object->setQuizFullScoreInLec($conn,$lecture_id)) {
			if ($res = $quiz_in_lec_object->dbFetchArr()) {
				$full_score = $res["full_score"];
			}
			$quiz_in_lec_object->dbFreeResult();
		}

		if ($quiz_in_lec_object->setPersonSumQuizSocreInLec($conn,$lecture_id)) {
			while ($res = $quiz_in_lec_object->dbFetchArr()) {
				if ($res["total_score"] == $full_score) {
					$pres_arr[$res["uid"]] = 1;
				} else if (($res["total_score"]/$full_score*100) >= $quiz_percent) {
					$pres_arr[$res["uid"]] = 2;
				} else {
					$pres_arr[$res["uid"]] = 3;
				}
			}
			$quiz_in_lec_object->dbFreeResult();
		}
		return $pres_arr;
	}

	function getQuizPracPres ($conn, $event_link_object,
	$right_percent, $quiz_percent, $lecture_id) {
		//ƥȤξ
		$pres_arr = array();
		$prac_right_arr = $this->getPraRightPres($conn, $event_link_object,$right_percent,$lecture_id);
		$quiz_arr = $this->getQuizPercentPres($conn,$quiz_percent,$lecture_id);

		foreach ($prac_right_arr as $uid=>$val) {
			if (!isset($quiz_arr[$uid])) {
				$pres_arr[$uid] = 3;
				continue;
			}
			if ($val == 1 && $quiz_arr[$uid] == 1) {
				$pres_arr[$uid] =1;
			} else if ($val<=2 && $quiz_arr[$uid] <= 2) {
				$pres_arr[$uid] =2;
			} else {
				$pres_arr[$uid] =3;
			}
			unset($quiz_arr[$uid]);
		}
		foreach ($quiz_arr as $uid=>$val) {
			$pres_arr[$uid] =3;
		}

		return $pres_arr;
	}

	function getThreePres ($conn, $event_link_object,
	$right_percent, $quiz_percent, $note_percent, $lecture_id) {
		//ƥȡꡦΡȤλĤ
		$pres_arr = array();
		$quiz_prac_arr = $this->getQuizPracPres($conn,$event_link_object,
			$right_percent,$quiz_percent,$lecture_id);
		$note_arr = $this->getNotePres($conn,$event_link_object,
			$note_percent,$lecture_id);

		foreach ($quiz_prac_arr as $uid=>$status) {
			if (!isset($note_arr[$uid])) {
				$pres_arr[$uid] = 3;
				continue;
			}
			if ($status==1 && $note_arr[$uid]==1) {
				$pres_arr[$uid] = 1;
			} else if ($status <=2 && $note_arr[$uid]==2) {
				$pres_arr[$uid] = 2;
			} else {
				$pres_arr[$uid] = 3;
			}
			unset($note_arr[$uid]);
		}
		foreach ($note_arr as $uid=>$status) {
			$pres_arr[$uid] = 3;
		}
		return $pres_arr;
	}
}

function encodeForUser ($str) {
	//$ret_str = htmlspecialchars(mb_convert_encoding($str,'UTF-8',XOOPS_SRT_ENCODE),3);
	$ret_str = htmlspecialchars($str,3);
	return $ret_str;
}

function encodeForDB ($str) {
	$ret_str = mb_convert_encoding($str,XOOPS_SRT_ENCODE,'UTF-8');
	return $ret_str;
}
?>