<?php
require_once '../../data/constant.php';
require_once '../../util/make_item.php';
require_once '../../util/validate.php';
$err_msg = "";
$conn = "";
$data_object = null;
if (NO_SINGLE_SIGNON == 0) {
	require('../../../../mainfile.php');
	require_once '../../data/xdb_access.php';
} else if (NO_SINGLE_SIGNON == 1) {
	require_once '../../data/db_access.php';
	ini_set("session.save_handler","files");
	session_start();
	$data_object = new CDbAccess();
	if ($data_object->openDB() == false) {
		$err_msg .= $data_object->err_msg;
	} else {
		$conn = $data_object->conn;
	}
}
require_once '../../data/table_access.php';

//ini_set("session.save_handler","files");
//session_start();
if (!isset($_SESSION[SESSION_ADMIN])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."teacher/login.php");
	exit;
}
$ses_arr = $_SESSION[SESSION_ADMIN];

$input_flag = "";
$up_flag = "";
$show_txt = "";

$department_sel = "";

$dif_sel = "";

$is_item_display = "none";

$answer = "";
$department_id = "";
$level_id = "";
$vote_title = "";
$vote_text = "";

$comment = "";
$img_url = "";

$lecture_id = "";

if (!isset($_REQUEST['lecture_id']) || !is_numeric($_REQUEST['lecture_id'])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."teacher/login.php");
	exit;
}

$lecture_id = $_REQUEST['lecture_id'];

if ($_POST <> null) {
	if (isset($_POST['ans_txt']))$answer = intval($_POST['ans_txt']);
	if (isset($_POST['dep']))$department_id = intval($_POST['dep']);
	if (isset($_POST['vote_title']))$vote_title = htmlspecialchars($_POST['vote_title'],ENT_QUOTES);
	if (isset($_POST['vote_txt']))$vote_text = htmlspecialchars($_POST['vote_txt'],ENT_QUOTES);
	if (isset($_POST['comment']))$comment = htmlspecialchars($_POST['comment'],ENT_QUOTES);
	if (isset($_POST['img_url']))$img_url = htmlspecialchars($_POST['img_url'],ENT_QUOTES);

	if ($answer == 1 || $answer == 2) {
		$is_item_display = "inline";
	}
}

//$data_object = new CDbAccess();
//if ($data_object->openDB() == false) {
//	$err_msg .= $data_object->err_msg;
//} else {
	//$dep_object = new CCreateDepSelect($data_object->conn);
	$dep_object = new CCreateDepSelect($conn);
	$dep_object->setDataForInput();
	$department_sel = $dep_object->getPullDown("department", $department_id);
	$dep_dat_arr  = $dep_object->getBasicData();

if ($conn <> "" && is_object($data_object)) $data_object->closeDB();
//}

$show_data = file_get_contents('../../templates/ad_vote/instant_vote_form.tpl');
$show_data = str_replace(':ERR_MSG:', mb_convert_encoding($err_msg,'UTF-8', 'EUC-JP'), $show_data);

$show_data = str_replace(':PRAC_TITLE_TXT:', $vote_title, $show_data);
$show_data = str_replace(':PRAC_TXT_REP:', $vote_text, $show_data);

$show_data = str_replace(':DEP_SEL_REP:', $department_sel, $show_data);

$show_data = str_replace(':COMMENT_REP:', $comment, $show_data);

for ($i=0; $i<3; $i++) {
	$answer_selected = "";
	if ($answer === $i) $answer_selected = "SELECTED";
	$show_data = str_replace(':SELECTED_REP'.$i.':', $answer_selected, $show_data);
}

for ($i=0; $i <10; $i++) {
	$bango_rep = "";
	$item_txt_rep = "";
	if (isset($_POST['item_bango'.$i])) $bango_rep = htmlspecialchars($_POST['item_bango'.$i],ENT_QUOTES);
	if (isset($_POST['item_txt'.$i])) $item_txt_rep = htmlspecialchars($_POST['item_txt'.$i],ENT_QUOTES);
	$show_data = str_replace(':BANGO_REP'.$i.':', $bango_rep, $show_data);
	$show_data = str_replace(':ITEM_TXT_REP'.$i.':', $item_txt_rep, $show_data);
}
$show_data = str_replace(':DEL_BUTTON_REP:', "", $show_data);

$show_data = str_replace(':ITEM_DISPLAY_REP:', $is_item_display, $show_data);

$show_data = str_replace(':PRA_ID_REP:', "", $show_data);
$show_data = str_replace(':QUE_ID_REP:', "", $show_data);
$show_data = str_replace(':ACT_TYPE_REP:', "insert", $show_data);

$show_data = str_replace(':TEXT_ID_REP:', "", $show_data);
$show_data = str_replace(':PRAC_COM_REP:', "", $show_data);
$show_data = str_replace(':ANALYSIS_REP:', "", $show_data);
$show_data = str_replace(':CREATER_DISP_REP:', "", $show_data);

$show_data = str_replace(':IMG_URL_REP:', $img_url, $show_data);

$show_data = str_replace(':LECTURE_ID_REP:', $lecture_id, $show_data);

echo $show_data;
?>